#include <Zeolite.h>

// function for reporting API version to calling app
zeoexport const char* __stdcall zeoGetApiVersion(void) {
	//return "3.0.0";
	return "2.9.7";
}

// app function handle defs

typedef FARPROC (__stdcall* LPFNAPI_app_GetFuncHandle)(void* hID, const char* lpFuncHandle);
typedef void (__stdcall* LPFNAPI_app_ReportError)(void* hID, const char* lpErrorStr);
typedef void (__stdcall* LPFNAPI_app_WriteToLog)(void* hID, const char* lpMessage);

// var function handle defs

typedef ZVAR (__stdcall* LPFNAPI_var_Create)(void* hID, long VarID);
typedef ZVAR (__stdcall* LPFNAPI_var_CreateShared)(void* hID, long VarID, const char* lpVarName);
typedef bool (__stdcall* LPFNAPI_var_Delete)(void* hID, ZVAR hVar);
typedef bool (__stdcall* LPFNAPI_var_ReInit)(void* hID, ZVAR hVar, long VarID);
typedef bool (__stdcall* LPFNAPI_var_Rename)(void* hID, ZVAR hVar, const char* lpNewName);
typedef ZVAR (__stdcall* LPFNAPI_var_GetSharedVar)(void* hID, const char* lpVarName);
typedef const char* (__stdcall* LPFNAPI_var_GetName)(void* hID, ZVAR hVar);
typedef long (__stdcall* LPFNAPI_var_GetTypeID)(void* hID, ZVAR hVar);
typedef bool (__stdcall* LPFNAPI_var_IsType)(void* hID, ZVAR hVar, long VarID);
typedef bool (__stdcall* LPFNAPI_var_GetValue)(void* hID, ZVAR hVar, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_SetValue)(void* hID, ZVAR hVar, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_GetValueEx)(void* hID, ZVAR hVar, long VarID, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_SetValueEx)(void* hID, ZVAR hVar, long VarID, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_GetValueText)(void* hID, ZVAR hVar, ZSTR hStrVar);
typedef bool (__stdcall* LPFNAPI_var_SetValueText)(void* hID, ZVAR hVar, const char* lpValueText);
typedef bool (__stdcall* LPFNAPI_var_CopyValue)(void* hID, ZVAR hVarDest, ZVAR hVarSrc);
typedef bool (__stdcall* LPFNAPI_var_SetVarRef)(void* hID, ZVAR hPtrVar, ZVAR hSrcVar);
typedef bool (__stdcall* LPFNAPI_var_EditUI)(void* hID, ZVAR hVar, const char* lpPrompt, unsigned long Flags, ZLIST hOptions);
typedef void* (__stdcall* LPFNAPI_var_GetDataPtr)(void* hID, ZVAR hVar);

// type function handle defs

typedef long (__stdcall* LPFNAPI_type_GetID)(void* hID, const char* lpTypeName);
typedef bool (__stdcall* LPFNAPI_type_GetName)(void* hID, long VarID, ZSTR hStringVar);

// string function handle defs

typedef const char* (__stdcall* LPFNAPI_str_GetText)(void* hID, ZSTR hStr);
typedef bool (__stdcall* LPFNAPI_str_SetText)(void* hID, ZSTR hStr, const char* lpText);

// list function handle defs

typedef long (__stdcall* LPFNAPI_list_nItems)(void* hID, ZLIST hList);
typedef ZVAR (__stdcall* LPFNAPI_list_CreateItem)(void* hID, ZLIST hList, long VarID, const char* lpVarName);
typedef ZVAR (__stdcall* LPFNAPI_list_GetItemI)(void* hID, ZLIST hList, long index);
typedef ZVAR (__stdcall* LPFNAPI_list_GetItemA)(void* hID, ZLIST hList, const char* lpVarName);
typedef bool (__stdcall* LPFNAPI_list_DelItemI)(void* hID, ZLIST hList, long index);
typedef bool (__stdcall* LPFNAPI_list_DelItemA)(void* hID, ZLIST hList, const char* lpVarName);
typedef bool (__stdcall* LPFNAPI_list_DelAll)(void* hID, ZLIST hList);
typedef bool (__stdcall* LPFNAPI_list_SortI)(void* hID, ZLIST hList, long From, long To);
typedef bool (__stdcall* LPFNAPI_list_SortA)(void* hID, ZLIST hList, const char* lpItemName, long To);
typedef bool (__stdcall* LPFNAPI_list_Append)(void* hID, ZLIST hList, ZLIST hList2);

// map function handle defs

typedef bool (__stdcall* LPFNAPI_map_Init)(void* hID, ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag);
typedef bool (__stdcall* LPFNAPI_map_Init2)(void* hID, ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag, unsigned long AllocMode, long TileSize);
typedef bool (__stdcall* LPFNAPI_map_Free)(void* hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetPixelSize)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetWrapFlag)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_SetWrapFlag)(void* hID, ZMAP hMap, bool WrapFlag);
typedef bool (__stdcall* LPFNAPI_map_GetBusyFlag)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_SetBusyFlag)(void* hID, ZMAP hMap, bool BusyFlag);
typedef long (__stdcall* LPFNAPI_map_GetMapType)(void* hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetWidth)(void* hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetHeight)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetPixel)(void* hID, ZMAP hMap, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_map_SetPixel)(void* hID, ZMAP hMap, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_map_GetMinMaxAlt)(void* hID, ZMAP hMap, float& minval, float& maxval);
typedef bool (__stdcall* LPFNAPI_map_SetMinMaxAlt)(void* hID, ZMAP hMap, float& minval, float& maxval);
typedef float (__stdcall* LPFNAPI_map_GetHorizScale)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_SetHorizScale)(void* hID, ZMAP hMap, float scale);
typedef bool (__stdcall* LPFNAPI_map_GetMosaicFlag)(void* hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMosaicTileSize)(void* hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMosaicTilesX)(void* hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMosaicTilesY)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetFlag)(void* hID, ZMAP hMap, long FlagID);
typedef bool (__stdcall* LPFNAPI_map_SetFlag)(void* hID, ZMAP hMap, long FlagID, bool FlagValue);
typedef unsigned (__stdcall* LPFNAPI_map_GetAllocMode)(void* hID, ZMAP hMap);
typedef ZLIST (__stdcall* LPFNAPI_map_GetSettingsList)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_SaveFile)(void* hID, ZMAP hMap, const char* lpFileName, ZFORMAT hFormat, bool SetFlags, bool ShowProgress);
typedef bool (__stdcall* LPFNAPI_map_LoadFile)(void* hID, ZMAP hMap, const char* lpFileName, long MapTypeID, ZFORMAT hFormat, bool SetFlags, bool ShowProgress);
typedef bool (__stdcall* LPFNAPI_map_GetNameInProject)(void* hID, ZMAP hMap, ZSTR hStr);
typedef bool (__stdcall* LPFNAPI_map_InitMosaic)(void* hID, ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag, const char* lpMosaicFileName, long TileSize, ZFORMAT hFormat, const char* lpProjMapName);
typedef bool (__stdcall* LPFNAPI_map_LoadMosaic)(void* hID, ZMAP hMap, const char* lpMosaicFileName);
typedef bool (__stdcall* LPFNAPI_map_SaveMosaic)(void* hID, ZMAP hMap);
typedef ZFORMAT (__stdcall* LPFNAPI_map_GetFormat)(void* hID, ZMAP hMap);
typedef bool  (__stdcall* LPFNAPI_map_SetFormat)(void* hID, ZMAP hMap, ZFORMAT hFormat);
typedef const char* (__stdcall* LPFNAPI_map_GetFilename)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_CombineMosaic)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_SplitToMosaic)(void* hID, ZMAP hMap, const char* lpMosaicFileName, long TileSize, ZFORMAT hFormat, const char* lpProjMapName);
typedef bool (__stdcall* LPFNAPI_map_SaveMosaicAs)(void* hID, ZMAP hMap, const char* lpFileName);
typedef bool (__stdcall* LPFNAPI_map_ExportMap)(void* hID, ZMAP hMap, const char* lpFileName, ZFORMAT hFormat, long nx, long ny);
typedef bool (__stdcall* LPFNAPI_map_ExportMosaic)(void* hID, ZMAP hMap, const char* lpFileName, ZFORMAT hFormat, long nx, long ny, long TileSize, const char* lpProjMapName);
typedef void*	(__stdcall* LPFNAPI_map_GetDataPtr)(void* hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_LinInterp)(void* hID, ZMAP hMap, double dx, double dy, void* pValue);
typedef void*	(__stdcall* LPFNAPI_map_GetMosaicTile)(void* hID, ZMAP hMap, long tx, long ty);
typedef bool (__stdcall* LPFNAPI_map_GenMipmaps)(void* hID, ZMAP hMap, long ResStep, long MaxLevel, long TileSize);
typedef bool (__stdcall* LPFNAPI_map_ClearMipmaps)(void* hID, ZMAP hMap);
typedef ZMAP (__stdcall* LPFNAPI_map_GetMipmapLevel)(void* hID, ZMAP hMap, long MipLevel);
typedef long (__stdcall* LPFNAPI_map_GetMipmapResStep)(void* hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMipmapMaxLevel)(void* hID, ZMAP hMap);

// mosaic tile function defs

typedef bool (__stdcall* LPFNAPI_tile_GetMinMaxAlt)(void* hID, void* hTile, float& minval, float& maxval);
typedef bool (__stdcall* LPFNAPI_tile_GetPixel)(void* hID, void* hTile, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_tile_SetPixel)(void* hID, void* hTile, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_tile_GetTileCoords)(void* hID, void* hTile, long& x, long& y);
typedef bool (__stdcall* LPFNAPI_tile_SetLock)(void* hID, void* hTile, bool LockState);
typedef void* (__stdcall* LPFNAPI_tile_GetDataPtr)(void* hID, void* hTile);
typedef bool (__stdcall* LPFNAPI_tile_MarkChanged)(void* hID, void* hTile);

// format function handle defs

typedef ZFORMAT (__stdcall* LPFNAPI_format_Create)(void* hID, const char* lpMapName, const char* lpLongName, const char* lpFileExt, const char* lpNativeProgramName);
typedef ZFORMAT (__stdcall* LPFNAPI_format_CreateGeneric)(void* hID, long MapTypeID, const char* lpLongName, const char* lpFileExt, const char* lpNativeProgramName);
typedef ZFORMAT (__stdcall* LPFNAPI_format_GetActiveFormat)(void* hID, const char* lpMapName, long MapTypeID);
typedef ZFORMAT (__stdcall* LPFNAPI_format_GetDefaultFormat)(void* hID, const char* lpMapName, long MapTypeID);
typedef bool (__stdcall* LPFNAPI_format_SetFlags)(void* hID, ZFORMAT hFormat, unsigned long Flags);
typedef unsigned long (__stdcall* LPFNAPI_format_GetFlags)(void* hID, ZFORMAT hFormat);
typedef bool (__stdcall* LPFNAPI_format_SetInfoStr)(void* hID, ZFORMAT hFormat, const char* lpInfoStr);
typedef const char* (__stdcall* LPFNAPI_format_GetExt)(void* hID, ZFORMAT hFormat);
typedef ZLIST (__stdcall* LPFNAPI_format_GetOptionList)(void* hID, ZFORMAT hFormat);
typedef bool (__stdcall* LPFNAPI_format_GetOptionValue)(void* hID, ZFORMAT hFormat, const char* lpOptionName, long VarID, void* pValue);
typedef bool (__stdcall* LPFNAPI_format_SetOptionValue)(void* hID, ZFORMAT hFormat, const char* lpOptionName, long VarID, void* pValue);
typedef ZFORMAT (__stdcall* LPFNAPI_format_GetFormatByExt)(void* hID, const char* lpMapName, long MapTypeID, const char* lpFileExt);
typedef ZLIST (__stdcall* LPFNAPI_format_GetFormatList)(void* hID, const char* lpMapName, long MapTypeID);


// prog box function handle defs

typedef bool (__stdcall* LPFNAPI_progbox_ShowWnd)(void* hID, ZVAR hProgWnd, unsigned long Flags);
typedef bool (__stdcall* LPFNAPI_progbox_HideWnd)(void* hID, ZVAR hProgWnd);
typedef bool (__stdcall* LPFNAPI_progbox_SetTitle)(void* hID, ZVAR hProgWnd, const char* lpTitleText);
typedef bool (__stdcall* LPFNAPI_progbox_SetProgress)(void* hID, ZVAR hProgWnd, __int64 p, __int64 pmax);

// file selector function handle defs

typedef bool (__stdcall* LPFNAPI_filesel_InitFS)(void* hID, ZVAR hFileSel, bool OpenFileFlag, const char* lpFileName, const char* lpFilterStr, const char* lpDefaultExt, const char* lpDefaultDir);
typedef bool (__stdcall* LPFNAPI_filesel_GetCurSelA)(void* hID, ZVAR hFileSel, ZSTR hReturnStr);

// dir selector functions

typedef bool (__stdcall* LPFNAPI_dirsel_InitDS)(void* hID, ZVAR hDirSel, const char* lpStartDir);
typedef bool (__stdcall* LPFNAPI_dirsel_GetCurSelA)(void* hID, ZVAR hDirSel, ZSTR hReturnStr);

// combo box function handle defs

typedef bool (__stdcall* LPFNAPI_combosel_InitCS)(void* hID, ZVAR hComboSel, const char* lpOptionsStr, const char* lpCurSelStr);
typedef bool (__stdcall* LPFNAPI_combosel_GetOptionsA)(void* hID, ZVAR hComboSel, ZSTR hReturnStr);
typedef bool (__stdcall* LPFNAPI_combosel_SetOptionsA)(void* hID, ZVAR hComboSel, const char* lpOptionsStr);
typedef bool (__stdcall* LPFNAPI_combosel_GetCurSelA)(void* hID, ZVAR hComboSel, ZSTR hReturnStr);
typedef bool (__stdcall* LPFNAPI_combosel_SetCurSelA)(void* hID, ZVAR hComboSel, const char* lpOptionStr);
typedef bool (__stdcall* LPFNAPI_combosel_SetCurSelI)(void* hID, ZVAR hComboSel, long SelID);
typedef long (__stdcall* LPFNAPI_combosel_GetCurSelI)(void* hID, ZVAR hComboSel);


// buffer function handle defs

typedef bool (__stdcall* LPFNAPI_buffer_Init)(void* hID, ZVAR hBuf, long nItems, long ItemSize);
typedef bool (__stdcall* LPFNAPI_buffer_InitByType)(void* hID, ZVAR hBuf, long nItems, long ItemTypeID);
typedef bool (__stdcall* LPFNAPI_buffer_Free)(void* hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_nItems)(void* hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_MemSize)(void* hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_ItemSize)(void* hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_ItemType)(void* hID, ZVAR hBuf);
typedef void* (__stdcall* LPFNAPI_buffer_GetPtr)(void* hID, ZVAR hBuf);
typedef bool (__stdcall* LPFNAPI_buffer_GetValue)(void* hID, ZVAR hBuf, long index, void* pValue);
typedef bool (__stdcall* LPFNAPI_buffer_SetValue)(void* hID, ZVAR hBuf, long index, void* pValue);

// extension functions

typedef ZFUNC (__stdcall* LPFNAPI_func_Load)(void* hID, const char* lpFnName, const char* lpExportName, long rvalVarID, ZLIST hArgList);
typedef ZFUNC (__stdcall* LPFNAPI_func_GetFunc)(void* hID, const char* lpFnName);
typedef long (__stdcall* LPFNAPI_func_GetReturnTypeID)(void* hID, ZFUNC hFunc);
typedef bool (__stdcall* LPFNAPI_func_GetArgListPrototype)(void* hID,  ZFUNC hFunc, ZLIST hArgList);
typedef bool (__stdcall* LPFNAPI_func_Execute)(void* hID, ZFUNC hFunc, ZLIST hArgList, ZVAR *ppRval);

// script functions

typedef bool (__stdcall* LPFNAPI_script_Execute)(void* hID, const char* lpLangName, const char* lpScript, ZVAR hRval);

// session ID

static void* m_hID = NULL;
void*	zeoGetHID() { return m_hID; }

// app function handles

static LPFNAPI_app_GetFuncHandle	m_lpfnGetFuncHandle = NULL;
static LPFNAPI_app_ReportError		m_lpfnReportError = NULL;
static LPFNAPI_app_WriteToLog		m_lpfnWriteToLog = NULL;

// var function handles

static LPFNAPI_var_Create			m_lpfn_var_Create = NULL;
static LPFNAPI_var_CreateShared		m_lpfn_var_CreateShared = NULL;
static LPFNAPI_var_Delete			m_lpfn_var_Delete = NULL;
static LPFNAPI_var_ReInit			m_lpfn_var_ReInit = NULL;
static LPFNAPI_var_Rename			m_lpfn_var_Rename = NULL;
static LPFNAPI_var_GetSharedVar		m_lpfn_var_GetSharedVar = NULL;
static LPFNAPI_var_GetName			m_lpfn_var_GetName = NULL;
static LPFNAPI_var_GetTypeID		m_lpfn_var_GetTypeID = NULL;
static LPFNAPI_var_IsType			m_lpfn_var_IsType = NULL;
static LPFNAPI_var_GetValue			m_lpfn_var_GetValue = NULL;
static LPFNAPI_var_SetValue			m_lpfn_var_SetValue = NULL;
static LPFNAPI_var_GetValueEx		m_lpfn_var_GetValueEx = NULL;
static LPFNAPI_var_SetValueEx		m_lpfn_var_SetValueEx = NULL;
static LPFNAPI_var_GetValueText		m_lpfn_var_GetValueText = NULL;
static LPFNAPI_var_SetValueText		m_lpfn_var_SetValueText = NULL;
static LPFNAPI_var_CopyValue		m_lpfn_var_CopyValue = NULL;
static LPFNAPI_var_SetVarRef		m_lpfn_var_SetVarRef = NULL;
static LPFNAPI_var_EditUI			m_lpfn_var_EditUI = NULL;
static LPFNAPI_var_GetDataPtr		m_lpfn_var_GetDataPtr = NULL;

// type function handles

static LPFNAPI_type_GetID			m_lpfn_type_GetID = NULL;
static LPFNAPI_type_GetName			m_lpfn_type_GetName = NULL;

// string function handles

static LPFNAPI_str_GetText			m_lpfn_str_GetText = NULL;
static LPFNAPI_str_SetText			m_lpfn_str_SetText = NULL;

// list function handles

static LPFNAPI_list_nItems			m_lpfn_list_nItems = NULL;
static LPFNAPI_list_CreateItem		m_lpfn_list_CreateItem = NULL;
static LPFNAPI_list_GetItemI		m_lpfn_list_GetItemI = NULL;
static LPFNAPI_list_GetItemA		m_lpfn_list_GetItemA = NULL;
static LPFNAPI_list_DelItemI		m_lpfn_list_DelItemI = NULL;
static LPFNAPI_list_DelItemA		m_lpfn_list_DelItemA = NULL;
static LPFNAPI_list_DelAll			m_lpfn_list_DelAll = NULL;
static LPFNAPI_list_SortI			m_lpfn_list_SortI = NULL;
static LPFNAPI_list_SortA			m_lpfn_list_SortA = NULL;
static LPFNAPI_list_Append			m_lpfn_list_Append = NULL;

// map function handles

static LPFNAPI_map_Init					m_lpfn_map_Init = NULL;
static LPFNAPI_map_Init2				m_lpfn_map_Init2 = NULL;
static LPFNAPI_map_Free					m_lpfn_map_Free = NULL;
static LPFNAPI_map_GetMapType			m_lpfn_map_GetMapType = NULL;
static LPFNAPI_map_GetPixelSize			m_lpfn_map_GetPixelSize = NULL;
static LPFNAPI_map_GetWrapFlag			m_lpfn_map_GetWrapFlag = NULL;
static LPFNAPI_map_SetWrapFlag			m_lpfn_map_SetWrapFlag = NULL;
static LPFNAPI_map_GetBusyFlag			m_lpfn_map_GetBusyFlag = NULL;
static LPFNAPI_map_SetBusyFlag			m_lpfn_map_SetBusyFlag = NULL;
static LPFNAPI_map_GetWidth				m_lpfn_map_GetWidth = NULL;
static LPFNAPI_map_GetHeight			m_lpfn_map_GetHeight = NULL;
static LPFNAPI_map_GetPixel				m_lpfn_map_GetPixel = NULL;
static LPFNAPI_map_SetPixel				m_lpfn_map_SetPixel = NULL;
static LPFNAPI_map_GetMinMaxAlt			m_lpfn_map_GetMinMaxAlt = NULL;
static LPFNAPI_map_SetMinMaxAlt			m_lpfn_map_SetMinMaxAlt = NULL;
static LPFNAPI_map_GetHorizScale		m_lpfn_map_GetHorizScale = NULL;
static LPFNAPI_map_SetHorizScale		m_lpfn_map_SetHorizScale = NULL;
static LPFNAPI_map_GetMosaicFlag		m_lpfn_map_GetMosaicFlag = NULL;
static LPFNAPI_map_GetMosaicTileSize	m_lpfn_map_GetMosaicTileSize = NULL;
static LPFNAPI_map_GetMosaicTilesX		m_lpfn_map_GetMosaicTilesX = NULL;
static LPFNAPI_map_GetMosaicTilesY		m_lpfn_map_GetMosaicTilesY = NULL;
static LPFNAPI_map_GetFlag				m_lpfn_map_GetFlag = NULL;
static LPFNAPI_map_SetFlag				m_lpfn_map_SetFlag = NULL;
static LPFNAPI_map_GetAllocMode			m_lpfn_map_GetAllocMode = NULL;
static LPFNAPI_map_GetSettingsList		m_lpfn_map_GetSettingsList = NULL;
static LPFNAPI_map_SaveFile				m_lpfn_map_SaveFile = NULL;
static LPFNAPI_map_LoadFile				m_lpfn_map_LoadFile = NULL;
static LPFNAPI_map_GetNameInProject		m_lpfn_map_GetNameInProject = NULL;
static LPFNAPI_map_InitMosaic			m_lpfn_map_InitMosaic = NULL;
static LPFNAPI_map_LoadMosaic			m_lpfn_map_LoadMosaic = NULL;
static LPFNAPI_map_SaveMosaic			m_lpfn_map_SaveMosaic = NULL;
static LPFNAPI_map_GetFormat			m_lpfn_map_GetFormat = NULL;
static LPFNAPI_map_SetFormat			m_lpfn_map_SetFormat = NULL;
static LPFNAPI_map_GetFilename			m_lpfn_map_GetFilename = NULL;
static LPFNAPI_map_CombineMosaic		m_lpfn_map_CombineMosaic = NULL;
static LPFNAPI_map_SplitToMosaic		m_lpfn_map_SplitToMosaic = NULL;
static LPFNAPI_map_SaveMosaicAs			m_lpfn_map_SaveMosaicAs = NULL;
static LPFNAPI_map_ExportMap			m_lpfn_map_ExportMap = NULL;
static LPFNAPI_map_ExportMosaic			m_lpfn_map_ExportMosaic = NULL;
static LPFNAPI_map_GetDataPtr			m_lpfn_map_GetDataPtr = NULL;
static LPFNAPI_map_GetMosaicTile		m_lpfn_map_GetMosaicTile = NULL;
static LPFNAPI_map_GenMipmaps			m_lpfn_map_GenMipmaps = NULL;
static LPFNAPI_map_ClearMipmaps			m_lpfn_map_ClearMipmaps = NULL;
static LPFNAPI_map_GetMipmapLevel		m_lpfn_map_GetMipmapLevel = NULL;
static LPFNAPI_map_GetMipmapResStep		m_lpfn_map_GetMipmapResStep = NULL;
static LPFNAPI_map_GetMipmapMaxLevel	m_lpfn_map_GetMipmapMaxLevel = NULL;
static LPFNAPI_map_LinInterp			m_lpfn_map_LinInterp = NULL;

// mosaic tile function handles

static LPFNAPI_tile_GetMinMaxAlt		m_lpfn_tile_GetMinMaxAlt = NULL;
static LPFNAPI_tile_GetPixel			m_lpfn_tile_GetPixel = NULL;
static LPFNAPI_tile_SetPixel			m_lpfn_tile_SetPixel = NULL;
static LPFNAPI_tile_GetTileCoords		m_lpfn_tile_GetTileCoords = NULL;
static LPFNAPI_tile_SetLock				m_lpfn_tile_SetLock = NULL;
static LPFNAPI_tile_GetDataPtr			m_lpfn_tile_GetDataPtr = NULL;
static LPFNAPI_tile_MarkChanged			m_lpfn_tile_MarkChanged = NULL;

// format function handles

static LPFNAPI_format_Create			m_lpfn_format_Create = NULL;
static LPFNAPI_format_CreateGeneric		m_lpfn_format_CreateGeneric = NULL;
static LPFNAPI_format_GetActiveFormat	m_lpfn_format_GetActiveFormat = NULL;
static LPFNAPI_format_GetDefaultFormat	m_lpfn_format_GetDefaultFormat = NULL;
static LPFNAPI_format_SetFlags			m_lpfn_format_SetFlags = NULL;
static LPFNAPI_format_GetFlags			m_lpfn_format_GetFlags = NULL;
static LPFNAPI_format_SetInfoStr		m_lpfn_format_SetInfoStr = NULL;
static LPFNAPI_format_GetExt			m_lpfn_format_GetExt = NULL;
static LPFNAPI_format_GetOptionList		m_lpfn_format_GetOptionList = NULL;
static LPFNAPI_format_GetOptionValue	m_lpfn_format_GetOptionValue = NULL;
static LPFNAPI_format_SetOptionValue	m_lpfn_format_SetOptionValue = NULL;
static LPFNAPI_format_GetFormatByExt	m_lpfn_format_GetFormatByExt = NULL;
static LPFNAPI_format_GetFormatList		m_lpfn_format_GetFormatList = NULL;

// prog box function handles

static LPFNAPI_progbox_ShowWnd			m_lpfn_progbox_ShowWnd = NULL;
static LPFNAPI_progbox_HideWnd			m_lpfn_progbox_HideWnd = NULL;
static LPFNAPI_progbox_SetTitle			m_lpfn_progbox_SetTitle = NULL;
static LPFNAPI_progbox_SetProgress		m_lpfn_progbox_SetProgress = NULL;

// file selector function handles

static LPFNAPI_filesel_InitFS			m_lpfn_filesel_InitFS = NULL;
static LPFNAPI_filesel_GetCurSelA		m_lpfn_filesel_GetCurSelA = NULL;

// dir selector function handles

static LPFNAPI_dirsel_InitDS			m_lpfn_dirsel_InitDS = NULL;
static LPFNAPI_dirsel_GetCurSelA		m_lpfn_dirsel_GetCurSelA = NULL;

// combo box function handles

static LPFNAPI_combosel_InitCS			m_lpfn_combosel_InitCS = NULL;
static LPFNAPI_combosel_SetOptionsA		m_lpfn_combosel_SetOptionsA  = NULL;
static LPFNAPI_combosel_GetOptionsA		m_lpfn_combosel_GetOptionsA = NULL;
static LPFNAPI_combosel_SetCurSelA		m_lpfn_combosel_SetCurSelA  = NULL;
static LPFNAPI_combosel_GetCurSelA		m_lpfn_combosel_GetCurSelA = NULL;
static LPFNAPI_combosel_SetCurSelI		m_lpfn_combosel_SetCurSelI = NULL;
static LPFNAPI_combosel_GetCurSelI		m_lpfn_combosel_GetCurSelI = NULL;

// buffer function handles

static LPFNAPI_buffer_Init			m_lpfn_buffer_Init = NULL;
static LPFNAPI_buffer_InitByType	m_lpfn_buffer_InitByType = NULL;
static LPFNAPI_buffer_Free			m_lpfn_buffer_Free = NULL;
static LPFNAPI_buffer_nItems		m_lpfn_buffer_nItems = NULL;
static LPFNAPI_buffer_MemSize		m_lpfn_buffer_MemSize = NULL;
static LPFNAPI_buffer_ItemSize		m_lpfn_buffer_ItemSize = NULL;
static LPFNAPI_buffer_ItemType		m_lpfn_buffer_ItemType = NULL;
static LPFNAPI_buffer_GetPtr		m_lpfn_buffer_GetPtr = NULL;
static LPFNAPI_buffer_GetValue		m_lpfn_buffer_GetValue = NULL;
static LPFNAPI_buffer_SetValue		m_lpfn_buffer_SetValue = NULL;

// extension function handles

static LPFNAPI_func_Load				m_lpfn_func_Load = NULL;
static LPFNAPI_func_GetFunc				m_lpfn_func_GetFunc = NULL;
static LPFNAPI_func_GetReturnTypeID		m_lpfn_func_GetReturnTypeID = NULL;
static LPFNAPI_func_GetArgListPrototype	m_lpfn_func_GetArgListPrototype = NULL;
static LPFNAPI_func_Execute				m_lpfn_func_Execute = NULL;

// script function handles

static LPFNAPI_script_Execute					m_lpfn_script_Execute = NULL;

//
// bootstrapping function
//

FARPROC zeoGetFuncHandle(const char* lpFuncName) {
	if(!m_lpfnGetFuncHandle) {
		zeoReportError("zeoGetFuncHandle error - API not initialised");
		return 0;
	}

	FARPROC hProc = m_lpfnGetFuncHandle(m_hID, lpFuncName);
	if(!hProc) {
		zeoReportError("zeoGetFuncHandle error - Function not found");
		return 0;
	}

	return hProc;
}


//bool zeoInitAPI(FARPROC pFunc, void* hID) {
zeoexport bool __stdcall zeoInitAPI(FARPROC pFunc, void* hID) {

	if(!pFunc) {
		MessageBox(0, _T("Invalid callback handle"), _T("Zeolite initialisation"), MB_ICONERROR);
		return false;
	}

	if(!hID) {
		MessageBox(0, _T("Invalid ID handle"), _T("Zeolite initialisation"), MB_ICONERROR);
		return false;
	}

	//store thr session ID
	m_hID = hID;

	// store the handle to the function by which we load more function handles
	m_lpfnGetFuncHandle = (LPFNAPI_app_GetFuncHandle)pFunc;

	// start loading functions from application

	//
	// app functions
	//

	m_lpfnReportError = (LPFNAPI_app_ReportError)zeoGetFuncHandle("app.ReportError");
	m_lpfnWriteToLog = (LPFNAPI_app_WriteToLog)zeoGetFuncHandle("app.WriteToLog");

	//
	// var functions
	//

	m_lpfn_var_CreateShared = (LPFNAPI_var_CreateShared)zeoGetFuncHandle("var.CreateShared");
	m_lpfn_var_Create = (LPFNAPI_var_Create)zeoGetFuncHandle("var.Create");
	m_lpfn_var_Delete = (LPFNAPI_var_Delete)zeoGetFuncHandle("var.Delete");
	m_lpfn_var_ReInit = (LPFNAPI_var_ReInit)zeoGetFuncHandle("var.ReInit");
	m_lpfn_var_Rename = (LPFNAPI_var_Rename)zeoGetFuncHandle("var.Rename");
	m_lpfn_var_GetSharedVar = (LPFNAPI_var_GetSharedVar)zeoGetFuncHandle("var.GetSharedVar");
	m_lpfn_var_GetName = (LPFNAPI_var_GetName)zeoGetFuncHandle("var.GetName");
	m_lpfn_var_GetTypeID = (LPFNAPI_var_GetTypeID)zeoGetFuncHandle("var.GetTypeID");
	m_lpfn_var_IsType = (LPFNAPI_var_IsType)zeoGetFuncHandle("var.IsType");
	m_lpfn_var_GetValue = (LPFNAPI_var_GetValue)zeoGetFuncHandle("var.GetValue");
	m_lpfn_var_SetValue = (LPFNAPI_var_SetValue)zeoGetFuncHandle("var.SetValue");
	m_lpfn_var_GetValueEx = (LPFNAPI_var_GetValueEx)zeoGetFuncHandle("var.GetValueEx");
	m_lpfn_var_SetValueEx = (LPFNAPI_var_SetValueEx)zeoGetFuncHandle("var.SetValueEx");
	m_lpfn_var_GetValueText = (LPFNAPI_var_GetValueText)zeoGetFuncHandle("var.GetValueText");
	m_lpfn_var_SetValueText = (LPFNAPI_var_SetValueText)zeoGetFuncHandle("var.SetValueText");
	m_lpfn_var_CopyValue = (LPFNAPI_var_CopyValue)zeoGetFuncHandle("var.CopyValue");
	m_lpfn_var_SetVarRef = (LPFNAPI_var_SetVarRef)zeoGetFuncHandle("var.SetVarRef");
	m_lpfn_var_EditUI = (LPFNAPI_var_EditUI)zeoGetFuncHandle("var.EditUI");
	m_lpfn_var_GetDataPtr = (LPFNAPI_var_GetDataPtr)zeoGetFuncHandle("var.GetDataPtr");

	//
	// type functions
	//

	m_lpfn_type_GetID = (LPFNAPI_type_GetID)zeoGetFuncHandle("type.GetID");
	m_lpfn_type_GetName = (LPFNAPI_type_GetName)zeoGetFuncHandle("type.GetName");

	//
	// string functions
	//

	m_lpfn_str_GetText = (LPFNAPI_str_GetText)zeoGetFuncHandle("str.GetText");
	m_lpfn_str_SetText = (LPFNAPI_str_SetText)zeoGetFuncHandle("str.SetText");

	//
	// list functions
	//

	m_lpfn_list_nItems = (LPFNAPI_list_nItems)zeoGetFuncHandle("list.nItems");
	m_lpfn_list_CreateItem = (LPFNAPI_list_CreateItem)zeoGetFuncHandle("list.CreateItem");
	m_lpfn_list_GetItemI = (LPFNAPI_list_GetItemI)zeoGetFuncHandle("list.GetItemI");
	m_lpfn_list_GetItemA = (LPFNAPI_list_GetItemA)zeoGetFuncHandle("list.GetItemA");
	m_lpfn_list_DelItemI = (LPFNAPI_list_DelItemI)zeoGetFuncHandle("list.DelItemI");
	m_lpfn_list_DelItemA = (LPFNAPI_list_DelItemA)zeoGetFuncHandle("list.DelItemA");
	m_lpfn_list_DelAll = (LPFNAPI_list_DelAll)zeoGetFuncHandle("list.DelAll");
	m_lpfn_list_SortI = (LPFNAPI_list_SortI)zeoGetFuncHandle("list.SortI");
	m_lpfn_list_SortA = (LPFNAPI_list_SortA)zeoGetFuncHandle("list.SortA");
	m_lpfn_list_Append = (LPFNAPI_list_Append)zeoGetFuncHandle("list.Append");

	//
	// map functions
	//

	m_lpfn_map_Init = (LPFNAPI_map_Init)zeoGetFuncHandle("map.Init");
	m_lpfn_map_Init2 = (LPFNAPI_map_Init2)zeoGetFuncHandle("map.Init2");
	m_lpfn_map_Free = (LPFNAPI_map_Free)zeoGetFuncHandle("map.Free");
	m_lpfn_map_GetMapType = (LPFNAPI_map_GetPixelSize)zeoGetFuncHandle("map.GetMapType");
	m_lpfn_map_GetPixelSize = (LPFNAPI_map_GetPixelSize)zeoGetFuncHandle("map.GetPixelSize");
	m_lpfn_map_GetWrapFlag = (LPFNAPI_map_GetWrapFlag)zeoGetFuncHandle("map.GetWrapFlag");
	m_lpfn_map_SetWrapFlag = (LPFNAPI_map_SetWrapFlag)zeoGetFuncHandle("map.SetWrapFlag");
	m_lpfn_map_GetBusyFlag = (LPFNAPI_map_GetBusyFlag)zeoGetFuncHandle("map.GetBusyFlag");
	m_lpfn_map_SetBusyFlag = (LPFNAPI_map_SetBusyFlag)zeoGetFuncHandle("map.SetBusyFlag");
	m_lpfn_map_GetWidth = (LPFNAPI_map_GetWidth)zeoGetFuncHandle("map.GetWidth");
	m_lpfn_map_GetHeight = (LPFNAPI_map_GetHeight)zeoGetFuncHandle("map.GetHeight");
	m_lpfn_map_GetPixel = (LPFNAPI_map_GetPixel)zeoGetFuncHandle("map.GetPixel");
	m_lpfn_map_SetPixel = (LPFNAPI_map_SetPixel)zeoGetFuncHandle("map.SetPixel");
	m_lpfn_map_GetMinMaxAlt = (LPFNAPI_map_GetMinMaxAlt)zeoGetFuncHandle("map.GetMinMaxAlt");
	m_lpfn_map_SetMinMaxAlt = (LPFNAPI_map_SetMinMaxAlt)zeoGetFuncHandle("map.SetMinMaxAlt");
	m_lpfn_map_GetHorizScale = (LPFNAPI_map_GetHorizScale)zeoGetFuncHandle("map.GetHorizScale");
	m_lpfn_map_SetHorizScale = (LPFNAPI_map_SetHorizScale)zeoGetFuncHandle("map.SetHorizScale");
	m_lpfn_map_GetMosaicFlag = (LPFNAPI_map_GetMosaicFlag)zeoGetFuncHandle("map.GetMosaicFlag");
	m_lpfn_map_GetMosaicTileSize = (LPFNAPI_map_GetMosaicTileSize)zeoGetFuncHandle("map.GetMosaicTileSize");
	m_lpfn_map_GetMosaicTilesX = (LPFNAPI_map_GetMosaicTilesX)zeoGetFuncHandle("map.GetMosaicTilesX");
	m_lpfn_map_GetMosaicTilesY = (LPFNAPI_map_GetMosaicTilesY)zeoGetFuncHandle("map.GetMosaicTilesY");
	m_lpfn_map_GetFlag = (LPFNAPI_map_GetFlag)zeoGetFuncHandle("map.GetFlag");
	m_lpfn_map_SetFlag = (LPFNAPI_map_SetFlag)zeoGetFuncHandle("map.SetFlag");
	m_lpfn_map_GetAllocMode = (LPFNAPI_map_GetAllocMode)zeoGetFuncHandle("map.GetAllocMode");
	m_lpfn_map_GetSettingsList = (LPFNAPI_map_GetSettingsList)zeoGetFuncHandle("map.GetSettingsList");
	m_lpfn_map_SaveFile = (LPFNAPI_map_SaveFile)zeoGetFuncHandle("map.SaveFile");
	m_lpfn_map_LoadFile = (LPFNAPI_map_LoadFile)zeoGetFuncHandle("map.LoadFile");
	m_lpfn_map_GetNameInProject = (LPFNAPI_map_GetNameInProject)zeoGetFuncHandle("map.GetNameInProject");
	m_lpfn_map_InitMosaic = (LPFNAPI_map_InitMosaic)zeoGetFuncHandle("map.InitMosaic");
	m_lpfn_map_LoadMosaic = (LPFNAPI_map_LoadMosaic)zeoGetFuncHandle("map.LoadMosaic");
	m_lpfn_map_SaveMosaic = (LPFNAPI_map_SaveMosaic)zeoGetFuncHandle("map.SaveMosaic");
	m_lpfn_map_GetFormat = (LPFNAPI_map_GetFormat)zeoGetFuncHandle("map.GetFormat");
	m_lpfn_map_SetFormat = (LPFNAPI_map_SetFormat)zeoGetFuncHandle("map.SetFormat");
	m_lpfn_map_GetFilename = (LPFNAPI_map_GetFilename)zeoGetFuncHandle("map.GetFilename");
	m_lpfn_map_CombineMosaic = (LPFNAPI_map_CombineMosaic)zeoGetFuncHandle("map.CombineMosaic");
	m_lpfn_map_SplitToMosaic = (LPFNAPI_map_SplitToMosaic)zeoGetFuncHandle("map.SplitToMosaic");
	m_lpfn_map_SaveMosaicAs = (LPFNAPI_map_SaveMosaicAs)zeoGetFuncHandle("map.SaveMosaicAs");
	m_lpfn_map_ExportMap = (LPFNAPI_map_ExportMap)zeoGetFuncHandle("map.ExportMap");
	m_lpfn_map_ExportMosaic = (LPFNAPI_map_ExportMosaic)zeoGetFuncHandle("map.ExportMosaic");
	m_lpfn_map_GetDataPtr = (LPFNAPI_map_GetDataPtr)zeoGetFuncHandle("map.GetDataPtr");
	m_lpfn_map_LinInterp = (LPFNAPI_map_LinInterp)zeoGetFuncHandle("map.LinInterp");
	m_lpfn_map_GetMosaicTile = (LPFNAPI_map_GetMosaicTile)zeoGetFuncHandle("map.GetMosaicTile");

	m_lpfn_map_GenMipmaps = (LPFNAPI_map_GenMipmaps)zeoGetFuncHandle("map.GenMipmaps");
	m_lpfn_map_ClearMipmaps = (LPFNAPI_map_ClearMipmaps)zeoGetFuncHandle("map.ClearMipmaps");
	m_lpfn_map_GetMipmapLevel = (LPFNAPI_map_GetMipmapLevel)zeoGetFuncHandle("map.GetMipmapLevel");
	m_lpfn_map_GetMipmapResStep = (LPFNAPI_map_GetMipmapResStep)zeoGetFuncHandle("map.GetMipmapResStep");
	m_lpfn_map_GetMipmapMaxLevel = (LPFNAPI_map_GetMipmapMaxLevel)zeoGetFuncHandle("map.GetMipmapMaxLevel");

	//
	// mosaic tile functions
	//

	m_lpfn_tile_GetMinMaxAlt = (LPFNAPI_tile_GetMinMaxAlt)zeoGetFuncHandle("tile.GetMinMaxAlt");
	m_lpfn_tile_GetPixel = (LPFNAPI_tile_GetPixel)zeoGetFuncHandle("tile.GetPixel");
	m_lpfn_tile_SetPixel = (LPFNAPI_tile_SetPixel)zeoGetFuncHandle("tile.SetPixel");
	m_lpfn_tile_GetTileCoords = (LPFNAPI_tile_GetTileCoords)zeoGetFuncHandle("tile.GetTileCoords");
	m_lpfn_tile_SetLock = (LPFNAPI_tile_SetLock)zeoGetFuncHandle("tile.SetLock");
	m_lpfn_tile_GetDataPtr = (LPFNAPI_tile_GetDataPtr)zeoGetFuncHandle("tile.GetDataPtr");
	m_lpfn_tile_MarkChanged = (LPFNAPI_tile_MarkChanged)zeoGetFuncHandle("tile.MarkChanged");

	//
	// format functions
	//

	m_lpfn_format_Create = (LPFNAPI_format_Create)zeoGetFuncHandle("format.Create");
	m_lpfn_format_CreateGeneric = (LPFNAPI_format_CreateGeneric)zeoGetFuncHandle("format.CreateGeneric");
	m_lpfn_format_SetFlags = (LPFNAPI_format_SetFlags)zeoGetFuncHandle("format.SetFlags");
	m_lpfn_format_GetFlags = (LPFNAPI_format_GetFlags)zeoGetFuncHandle("format.GetFlags");
	m_lpfn_format_SetInfoStr = (LPFNAPI_format_SetInfoStr)zeoGetFuncHandle("format.SetInfoStr");
	m_lpfn_format_GetExt = (LPFNAPI_format_GetExt)zeoGetFuncHandle("format.GetExt");
	m_lpfn_format_GetOptionList = (LPFNAPI_format_GetOptionList)zeoGetFuncHandle("format.GetOptionList");
	m_lpfn_format_GetOptionValue = (LPFNAPI_format_GetOptionValue)zeoGetFuncHandle("format.GetOptionValue");
	m_lpfn_format_SetOptionValue = (LPFNAPI_format_SetOptionValue)zeoGetFuncHandle("format.SetOptionValue");
	m_lpfn_format_GetFormatByExt = (LPFNAPI_format_GetFormatByExt)zeoGetFuncHandle("format.GetFormatByExt");
	m_lpfn_format_GetActiveFormat = (LPFNAPI_format_GetActiveFormat)zeoGetFuncHandle("format.GetActiveFormat");
	m_lpfn_format_GetDefaultFormat = (LPFNAPI_format_GetDefaultFormat)zeoGetFuncHandle("format.GetDefaultFormat");
	m_lpfn_format_GetFormatList = (LPFNAPI_format_GetFormatList)zeoGetFuncHandle("format.GetFormatList");
	
	//
	// prog box function handles
	//

	m_lpfn_progbox_ShowWnd = (LPFNAPI_progbox_ShowWnd)zeoGetFuncHandle("progbox.ShowWnd");
	m_lpfn_progbox_HideWnd = (LPFNAPI_progbox_HideWnd)zeoGetFuncHandle("progbox.HideWnd");
	m_lpfn_progbox_SetTitle = (LPFNAPI_progbox_SetTitle)zeoGetFuncHandle("progbox.SetTitle");
	m_lpfn_progbox_SetProgress = (LPFNAPI_progbox_SetProgress)zeoGetFuncHandle("progbox.SetProgress");

	//
	// file selector function handles
	//

	m_lpfn_filesel_InitFS = (LPFNAPI_filesel_InitFS)zeoGetFuncHandle("filesel.InitFS");
	m_lpfn_filesel_GetCurSelA = (LPFNAPI_filesel_GetCurSelA)zeoGetFuncHandle("filesel.GetCurSelA");

	//
	// dir selector function handles
	//

	m_lpfn_dirsel_InitDS = (LPFNAPI_dirsel_InitDS)zeoGetFuncHandle("dirsel.InitDS");
	m_lpfn_dirsel_GetCurSelA = (LPFNAPI_dirsel_GetCurSelA)zeoGetFuncHandle("dirsel.GetCurSelA");

	//
	// combo box function handles
	//

	m_lpfn_combosel_InitCS = (LPFNAPI_combosel_InitCS)zeoGetFuncHandle("combosel.InitCS");
	m_lpfn_combosel_SetOptionsA = (LPFNAPI_combosel_SetOptionsA)zeoGetFuncHandle("combosel.SetOptionsA");
	m_lpfn_combosel_GetOptionsA = (LPFNAPI_combosel_GetOptionsA)zeoGetFuncHandle("combosel.GetOptionsA");
	m_lpfn_combosel_SetCurSelA = (LPFNAPI_combosel_SetCurSelA)zeoGetFuncHandle("combosel.SetCurSelA");
	m_lpfn_combosel_GetCurSelA = (LPFNAPI_combosel_GetCurSelA)zeoGetFuncHandle("combosel.GetCurSelA");
	m_lpfn_combosel_SetCurSelI = (LPFNAPI_combosel_SetCurSelI)zeoGetFuncHandle("combosel.SetCurSelI");
	m_lpfn_combosel_GetCurSelI = (LPFNAPI_combosel_GetCurSelI)zeoGetFuncHandle("combosel.GetCurSelI");

	//
	// buffer function handles
	//

	m_lpfn_buffer_Init = (LPFNAPI_buffer_Init)zeoGetFuncHandle("buffer.Init");
	m_lpfn_buffer_InitByType = (LPFNAPI_buffer_InitByType)zeoGetFuncHandle("buffer.InitByType");
	m_lpfn_buffer_Free = (LPFNAPI_buffer_Free)zeoGetFuncHandle("buffer.Free");
	m_lpfn_buffer_nItems = (LPFNAPI_buffer_nItems)zeoGetFuncHandle("buffer.nItems");
	m_lpfn_buffer_MemSize = (LPFNAPI_buffer_MemSize)zeoGetFuncHandle("buffer.MemSize");
	m_lpfn_buffer_ItemSize = (LPFNAPI_buffer_ItemSize)zeoGetFuncHandle("buffer.ItemSize");
	m_lpfn_buffer_ItemType = (LPFNAPI_buffer_ItemType)zeoGetFuncHandle("buffer.ItemType");
	m_lpfn_buffer_GetPtr = (LPFNAPI_buffer_GetPtr)zeoGetFuncHandle("buffer.GetPtr");
	m_lpfn_buffer_GetValue = (LPFNAPI_buffer_GetValue)zeoGetFuncHandle("buffer.GetValue");
	m_lpfn_buffer_SetValue = (LPFNAPI_buffer_SetValue)zeoGetFuncHandle("buffer.SetValue");

	//
	// extension function handles
	//

	m_lpfn_func_Load = (LPFNAPI_func_Load)zeoGetFuncHandle("func.Load");
	m_lpfn_func_GetFunc = (LPFNAPI_func_GetFunc)zeoGetFuncHandle("func.GetFunc");
	m_lpfn_func_GetReturnTypeID = (LPFNAPI_func_GetReturnTypeID)zeoGetFuncHandle("func.GetReturnTypeID");
	m_lpfn_func_GetArgListPrototype = (LPFNAPI_func_GetArgListPrototype)zeoGetFuncHandle("func.GetArgListPrototype");
	m_lpfn_func_Execute = (LPFNAPI_func_Execute)zeoGetFuncHandle("func.Execute");

	//
	// script function handles
	//
	m_lpfn_script_Execute = (LPFNAPI_script_Execute)zeoGetFuncHandle("script.Execute");

	return true;
}

//
// api functions
//

void zeoReportError(const char* lpErrorMessage) {
	if(!m_lpfnReportError) {
		MessageBoxA(0, lpErrorMessage, "Zeolite error", MB_ICONERROR);
		return;
	}

	m_lpfnReportError(m_hID, lpErrorMessage);
}

void zeoWriteToLog(const char* lpMessage) {
	if(!m_lpfnWriteToLog) {
		zeoReportError("zeoWriteToLog error - function not found");
		return;
	}

	m_lpfnWriteToLog(m_hID, lpMessage);
}

//
// var functions
//

ZVAR zvar_Create(long VarID) {
	if(!m_lpfn_var_Create) {
		zeoReportError("zvar_Create error - function not found");
		return 0;
	}

	return m_lpfn_var_Create(m_hID, VarID);
}
ZVAR zvar_CreateShared(long VarID, const char* lpVarName) {
	if(!m_lpfn_var_CreateShared) {
		zeoReportError("zvar_CreateShared error - function not found");
		return 0;
	}

	return m_lpfn_var_CreateShared(m_hID, VarID, lpVarName);
}
bool zvar_Delete(ZVAR &hVar) {
	if(!m_lpfn_var_Delete) {
		zeoReportError("zvar_Delete error - function not found");
		return false;
	}

	bool rval =  m_lpfn_var_Delete(m_hID, hVar);
	if(rval) {
		hVar = 0;
	}

	return rval;
}
bool zvar_ReInit(ZVAR hVar, long VarID) {
	if(!m_lpfn_var_ReInit) {
		zeoReportError("zvar_ReInit error - function not found");
		return false;
	}

	return m_lpfn_var_ReInit(m_hID, hVar, VarID);
}
bool zvar_Rename(ZVAR hVar, const char* lpNewName) {
	if(!m_lpfn_var_Rename) {
		zeoReportError("zvar_Rename error - function not found");
		return false;
	}

	return m_lpfn_var_Rename(m_hID, hVar, lpNewName);
}
ZVAR zvar_GetSharedVar(const char* lpVarName) {
	if(!m_lpfn_var_GetSharedVar) {
		zeoReportError("zvar_GetSharedVar error - function not found");
		return 0;
	}

	return m_lpfn_var_GetSharedVar(m_hID, lpVarName);
}
const char* zvar_GetName(ZVAR hVar) {
	if(!m_lpfn_var_GetName) {
		zeoReportError("zvar_GetName error - function not found");
		return 0;
	}

	return m_lpfn_var_GetName(m_hID, hVar);
}
long zvar_GetTypeID(ZVAR hVar) {
	if(!m_lpfn_var_GetTypeID) {
		zeoReportError("zvar_GetTypeID error - function not found");
		return 0;
	}

	return m_lpfn_var_GetTypeID(m_hID, hVar);
}
bool zvar_IsType(ZVAR hVar, long VarID) {
	if(!m_lpfn_var_IsType) {
		zeoReportError("zvar_IsType error - function not found");
		return false;
	}

	return m_lpfn_var_IsType(m_hID, hVar, VarID);
}
bool zvar_GetValue(ZVAR hVar, void* pValue) {
	if(!m_lpfn_var_GetValue) {
		zeoReportError("zvar_GetValue error - function not found");
		return false;
	}

	return m_lpfn_var_GetValue(m_hID, hVar, pValue);
}
bool zvar_SetValue(ZVAR hVar, void* pValue) {
	if(!m_lpfn_var_SetValue) {
		zeoReportError("zvar_SetValue error - function not found");
		return false;
	}

	return m_lpfn_var_SetValue(m_hID, hVar, pValue);
}
bool zvar_GetValueEx(ZVAR hVar, long VarID, void* pValue) {
	if(!m_lpfn_var_GetValueEx) {
		zeoReportError("zvar_GetValueEx error - function not found");
		return false;
	}

	return m_lpfn_var_GetValueEx(m_hID, hVar, VarID, pValue);
}
bool zvar_SetValueEx(ZVAR hVar, long VarID, void* pValue) {
	if(!m_lpfn_var_SetValueEx) {
		zeoReportError("zvar_SetValueEx error - function not found");
		return false;
	}

	return m_lpfn_var_SetValueEx(m_hID, hVar, VarID, pValue);
}
bool zvar_GetValueText(ZVAR hVar, ZSTR hStrVar) {
	if(!m_lpfn_var_GetValueText) {
		zeoReportError("zvar_GetValueText error - function not found");
		return false;
	}

	return m_lpfn_var_GetValueText(m_hID, hVar, hStrVar);
}
bool zvar_SetValueText(ZVAR hVar, const char* lpValueText) {
	if(!m_lpfn_var_SetValueText) {
		zeoReportError("zvar_SetValueText error - function not found");
		return false;
	}

	return m_lpfn_var_SetValueText(m_hID, hVar, lpValueText);
}
bool zvar_CopyValue(ZVAR hVarDest, ZVAR hVarSrc) {
	if(!m_lpfn_var_CopyValue) {
		zeoReportError("zvar_CopyValue error - function not found");
		return false;
	}

	return m_lpfn_var_CopyValue(m_hID, hVarDest, hVarSrc);
}
bool zvar_SetVarRef(ZVAR hPtrVar, ZVAR hSrcVar) {
	if(!m_lpfn_var_SetVarRef) {
		zeoReportError("zvar_SetVarRef error - function not found");
		return false;
	}

	return m_lpfn_var_SetVarRef(m_hID, hPtrVar, hSrcVar);
}
bool zvar_EditUI(ZVAR hVar, const char* lpPrompt, unsigned long Flags, ZLIST hOptions) {
	if(!m_lpfn_var_EditUI) {
		zeoReportError("zvar_EditUI error - function not found");
		return false;
	}

	return m_lpfn_var_EditUI(m_hID, hVar, lpPrompt, Flags, hOptions);
}
void* zvar_GetDataPtr(ZVAR hVar) {
	if(!m_lpfn_var_GetDataPtr) {
		zeoReportError("zvar_GetDataPtr error - function not found");
		return false;
	}

	return m_lpfn_var_GetDataPtr(m_hID, hVar);
}

//
// type functions
//

long ztype_GetID(const char* lpTypeName) {
	if(!m_lpfn_type_GetID) {
		zeoReportError("ztype_GetID error - function not found");
		return 0;
	}

	return m_lpfn_type_GetID(m_hID, lpTypeName);
}
bool ztype_GetName(long VarID, ZSTR hTypeName) {
	if(!m_lpfn_type_GetName) {
		zeoReportError("ztype_GetName error - function not found");
		return false;
	}

	return m_lpfn_type_GetName(m_hID, VarID, hTypeName);
}

//
// string functions
//

const char* zstr_GetText(ZSTR hStr) {
	if(!m_lpfn_str_GetText) {
		zeoReportError("zstr_GetText error - function not found");
		return 0;
	}

	return m_lpfn_str_GetText(m_hID, hStr);
}
bool zstr_SetText(ZSTR hStr, const char* lpText) {
	if(!m_lpfn_str_SetText) {
		zeoReportError("zstr_SetText error - function not found");
		return false;
	}

	return m_lpfn_str_SetText(m_hID, hStr, lpText);
}

//
// list functions
//

long zlist_nItems(ZLIST hList) {
	if(!m_lpfn_list_nItems) {
		zeoReportError("zlist_nItems error - function not found");
		return 0;
	}

	return m_lpfn_list_nItems(m_hID, hList);
}
ZVAR zlist_CreateItem(ZLIST hList, long VarID, const char* lpVarName) {
	if(!m_lpfn_list_CreateItem) {
		zeoReportError("zlist_CreateItem error - function not found");
		return 0;
	}

	return m_lpfn_list_CreateItem(m_hID, hList, VarID, lpVarName);
}
ZVAR zlist_GetItemI(ZLIST hList, long index) {
	if(!m_lpfn_list_GetItemI) {
		zeoReportError("zlist_GetItemI error - function not found");
		return 0;
	}

	return m_lpfn_list_GetItemI(m_hID, hList, index);
}
ZVAR zlist_GetItemA(ZLIST hList, const char* lpVarName) {
	if(!m_lpfn_list_GetItemA) {
		zeoReportError("zlist_GetItemA error - function not found");
		return 0;
	}

	return m_lpfn_list_GetItemA(m_hID, hList, lpVarName);
}
bool zlist_DelItemI(ZLIST hList, long index) {
	if(!m_lpfn_list_DelItemI) {
		zeoReportError("zlist_DelItemI error - function not found");
		return false;
	}

	return m_lpfn_list_DelItemI(m_hID, hList, index);
}
bool zlist_DelItemA(ZLIST hList, const char* lpVarName) {
	if(!m_lpfn_list_DelItemA) {
		zeoReportError("zlist_DelItemA error - function not found");
		return false;
	}

	return m_lpfn_list_DelItemA(m_hID, hList, lpVarName);
}
bool zlist_DelAll(ZLIST hList) {
	if(!m_lpfn_list_DelAll) {
		zeoReportError("zlist_DelAll error - function not found");
		return false;
	}

	return m_lpfn_list_DelAll(m_hID, hList);
}
bool zlist_SortI(ZLIST hList, long From, long To) {
	if(!m_lpfn_list_SortI) {
		zeoReportError("zlist_SortI error - function not found");
		return false;
	}

	return m_lpfn_list_SortI(m_hID, hList, From, To);
}
bool zlist_SortA(ZLIST hList, const char* lpItemName, long To) {
	if(!m_lpfn_list_SortA) {
		zeoReportError("zlist_SortA error - function not found");
		return false;
	}

	return m_lpfn_list_SortA(m_hID, hList, lpItemName, To);
}

bool zlist_Append(ZLIST hList, ZLIST hList2) {
	if(!m_lpfn_list_Append) {
		zeoReportError("zlist_Append error - function not found");
		return false;
	}

	return m_lpfn_list_Append(m_hID, hList, hList2);
}


//
// map functions
//

bool zmap_Init(ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag) {
	if(!m_lpfn_map_Init) {
		zeoReportError("zmap_Init error - function not found");
		return false;
	}

	return m_lpfn_map_Init(m_hID, hMap, nx, ny, MapTypeID, HorizScale, WrapFlag);
}
bool zmap_Init2(ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag, unsigned long AllocMode, long TileSize) {
	if(!m_lpfn_map_Init2) {
		zeoReportError("zmap_Init2 error - function not found");
		return false;
	}

	return m_lpfn_map_Init2(m_hID, hMap, nx, ny, MapTypeID, HorizScale, WrapFlag, AllocMode, TileSize);
}
bool zmap_Free(ZMAP hMap) {
	if(!m_lpfn_map_Free) {
		zeoReportError("zmap_Free error - function not found");
		return false;
	}

	return m_lpfn_map_Free(m_hID, hMap);
}
long zmap_GetMapType(ZMAP hMap) {
	if(!m_lpfn_map_GetMapType) {
		zeoReportError("zmap_GetMapType error - function not found");
		return 0;
	}

	return m_lpfn_map_GetMapType(m_hID, hMap);
}
long zmap_GetPixelSize(ZMAP hMap) {
	if(!m_lpfn_map_GetPixelSize) {
		zeoReportError("zmap_GetPixelSize error - function not found");
		return 0;
	}

	return m_lpfn_map_GetPixelSize(m_hID, hMap);
}
bool zmap_GetWrapFlag(ZMAP hMap) {
	if(!m_lpfn_map_GetWrapFlag) {
		zeoReportError("zmap_GetWrapFlag error - function not found");
		return false;
	}

	return m_lpfn_map_GetWrapFlag(m_hID, hMap);
}
bool zmap_SetWrapFlag(ZMAP hMap, bool WrapFlag) {
	if(!m_lpfn_map_SetWrapFlag) {
		zeoReportError("zmap_SetWrapFlag error - function not found");
		return false;
	}

	return m_lpfn_map_SetWrapFlag(m_hID, hMap, WrapFlag);
}
bool zmap_GetBusyFlag(ZMAP hMap) {
	if(!m_lpfn_map_GetBusyFlag) {
		zeoReportError("zmap_GetBusyFlag error - function not found");
		return false;
	}

	return m_lpfn_map_GetBusyFlag(m_hID, hMap);
}
bool zmap_SetBusyFlag(ZMAP hMap, bool BusyFlag) {
	if(!m_lpfn_map_SetBusyFlag) {
		zeoReportError("zmap_SetBusyFlag error - function not found");
		return false;
	}

	return m_lpfn_map_SetBusyFlag(m_hID, hMap, BusyFlag);
}
long zmap_GetWidth(ZMAP hMap) {
	if(!m_lpfn_map_GetWidth) {
		zeoReportError("zmap_GetWidth error - function not found");
		return 0;
	}

	return m_lpfn_map_GetWidth(m_hID, hMap);
}
long zmap_GetHeight(ZMAP hMap) {
	if(!m_lpfn_map_GetHeight) {
		zeoReportError("zmap_GetHeight error - function not found");
		return 0;
	}

	return m_lpfn_map_GetHeight(m_hID, hMap);
}
bool zmap_GetPixel(ZMAP hMap, long x, long y, void* pValue) {
	if(!m_lpfn_map_GetPixel) {
		zeoReportError("zmap_GetPixel error - function not found");
		return false;
	}

	return m_lpfn_map_GetPixel(m_hID, hMap, x, y, pValue);
}
bool zmap_SetPixel(ZMAP hMap, long x, long y, void* pValue) {
	if(!m_lpfn_map_SetPixel) {
		zeoReportError("zmap_SetPixel error - function not found");
		return false;
	}

	return m_lpfn_map_SetPixel(m_hID, hMap, x, y, pValue);
}
bool zmap_GetMinMaxAlt(ZMAP hMap, float& minval, float& maxval) {
	if(!m_lpfn_map_GetMinMaxAlt) {
		zeoReportError("zmap_GetMinMaxAlt error - function not found");
		return false;
	}

	return m_lpfn_map_GetMinMaxAlt(m_hID, hMap, minval, maxval);
}
bool zmap_SetMinMaxAlt(ZMAP hMap, float& minval, float& maxval) {
	if(!m_lpfn_map_SetMinMaxAlt) {
		zeoReportError("zmap_SetMinMaxAlt error - function not found");
		return false;
	}

	return m_lpfn_map_SetMinMaxAlt(m_hID, hMap, minval, maxval);
}
float zmap_GetHorizScale(ZMAP hMap) {
	if(!m_lpfn_map_GetHorizScale) {
		zeoReportError("zmap_GetHorizScale error - function not found");
		return false;
	}

	return m_lpfn_map_GetHorizScale(m_hID, hMap);
}
bool zmap_SetHorizScale(ZMAP hMap, float scale) {
	if(!m_lpfn_map_SetHorizScale) {
		zeoReportError("zmap_SetHorizScale error - function not found");
		return false;
	}

	return m_lpfn_map_SetHorizScale(m_hID, hMap, scale);
}
bool zmap_GetMosaicFlag(ZMAP hMap) {
	if(!m_lpfn_map_GetMosaicFlag) {
		zeoReportError("zmap_GetMosaicFlag error - function not found");
		return false;
	}

	return m_lpfn_map_GetMosaicFlag(m_hID, hMap);
}
long zmap_GetTileSize(ZMAP hMap) {
	if(!m_lpfn_map_GetMosaicTileSize) {
		zeoReportError("zmap_GetTileSize error - function not found");
		return 0;
	}

	return m_lpfn_map_GetMosaicTileSize(m_hID, hMap);
}
long zmap_GetTileCountX(ZMAP hMap) {
	if(!m_lpfn_map_GetMosaicTilesX) {
		zeoReportError("zmap_GetMosaicTilesX error - function not found");
		return 0;
	}

	return m_lpfn_map_GetMosaicTilesX(m_hID, hMap);
}
long zmap_GetTileCountY(ZMAP hMap) {
	if(!m_lpfn_map_GetMosaicTilesY) {
		zeoReportError("zmap_GetMosaicTilesY error - function not found");
		return 0;
	}

	return m_lpfn_map_GetMosaicTilesY(m_hID, hMap);
}
bool zmap_GetFlag(ZMAP hMap, long FlagID) {
	if(!m_lpfn_map_GetFlag) {
		zeoReportError("zmap_GetFlag error - function not found");
		return false;
	}

	return m_lpfn_map_GetFlag(m_hID, hMap, FlagID);
}
bool zmap_SetFlag(ZMAP hMap, long FlagID, bool FlagValue) {
	if(!m_lpfn_map_SetFlag) {
		zeoReportError("zmap_SetFlag error - function not found");
		return false;
	}

	return m_lpfn_map_SetFlag(m_hID, hMap, FlagID, FlagValue);
}
unsigned long zmap_GetAllocMode(ZMAP hMap) {
	if(!m_lpfn_map_GetAllocMode) {
		zeoReportError("zmap_GetAllocMode error - function not found");
		return 0;
	}

	return m_lpfn_map_GetAllocMode(m_hID, hMap);
}
ZLIST zmap_GetSettingsList(ZMAP hMap) {
	if(!m_lpfn_map_GetSettingsList) {
		zeoReportError("zmap_GetSettingsList error - function not found");
		return 0;
	}

	return m_lpfn_map_GetSettingsList(m_hID, hMap);
}

bool zmap_SaveFile(ZMAP hMap, const char* lpFileName, ZFORMAT hFormat, bool SetFlags, bool ShowProgress) {
	if(!m_lpfn_map_SaveFile) {
		zeoReportError("zmap_SaveFile error - function not found");
		return 0;
	}

	return m_lpfn_map_SaveFile(m_hID, hMap, lpFileName, hFormat, SetFlags, ShowProgress);
}

bool zmap_LoadFile(ZMAP hMap, const char* lpFileName, long MapTypeID, ZFORMAT hFormat, bool SetFlags, bool ShowProgress) {
	if(!m_lpfn_map_LoadFile) {
		zeoReportError("zmap_LoadFile error - function not found");
		return 0;
	}

	return m_lpfn_map_LoadFile(m_hID, hMap, lpFileName, MapTypeID, hFormat, SetFlags, ShowProgress);
}

bool zmap_GetNameInProject(ZMAP hMap, ZSTR hStr) {
	if(!m_lpfn_map_GetNameInProject) {
		zeoReportError("zmap_GetNameInProject error - function not found");
		return 0;
	}

	return m_lpfn_map_GetNameInProject(m_hID, hMap, hStr);
}

bool zmap_InitMosaic(ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag, const char* lpMosaicFileName, long TileSize, ZFORMAT hFormat, const char* lpProjMapName) {
	if(!m_lpfn_map_InitMosaic) {
		zeoReportError("zmap_InitMosaic error - function not found");
		return false;
	}

	return m_lpfn_map_InitMosaic(m_hID, hMap, nx, ny, MapTypeID, HorizScale, WrapFlag, lpMosaicFileName, TileSize, hFormat, lpProjMapName);
}
bool zmap_LoadMosaic(ZMAP hMap, const char* lpMosaicFileName) {
	if(!m_lpfn_map_LoadMosaic) {
		zeoReportError("zmap_LoadMosaic error - function not found");
		return false;
	}

	return m_lpfn_map_LoadMosaic(m_hID, hMap, lpMosaicFileName);
}
bool zmap_SaveMosaic(ZMAP hMap) {
	if(!m_lpfn_map_SaveMosaic) {
		zeoReportError("zmap_SaveMosaic error - function not found");
		return false;
	}

	return m_lpfn_map_SaveMosaic(m_hID, hMap);
}

ZFORMAT zmap_GetFormat(ZMAP hMap) {
	if(!m_lpfn_map_GetFormat) {
		zeoReportError("zmap_GetFormat error - function not found");
		return 0;
	}

	return m_lpfn_map_GetFormat(m_hID, hMap);
}
bool zmap_SetFormat(ZMAP hMap, ZFORMAT hFormat) {
	if(!m_lpfn_map_SetFormat) {
		zeoReportError("zmap_SetFormat error - function not found");
		return false;
	}

	return m_lpfn_map_SetFormat(m_hID, hMap, hFormat);
}
const char* zmap_GetFilename(ZMAP hMap) {
	if(!m_lpfn_map_GetFilename) {
		zeoReportError("zmap_GetFilename error - function not found");
		return 0;
	}

	return m_lpfn_map_GetFilename(m_hID, hMap);
}

bool zmap_CombineMosaic(ZMAP hMap) {
	if(!m_lpfn_map_CombineMosaic) {
		zeoReportError("zmap_CombineMosaic error - function not found");
		return 0;
	}

	return m_lpfn_map_CombineMosaic(m_hID, hMap);
}
bool zmap_SplitToMosaic(ZMAP hMap, const char* lpMosaicFileName, long TileSize, ZFORMAT hFormat, const char* lpProjMapName) {
	if(!m_lpfn_map_SplitToMosaic) {
		zeoReportError("zmap_SplitToMosaic error - function not found");
		return false;
	}

	return m_lpfn_map_SplitToMosaic(m_hID, hMap, lpMosaicFileName, TileSize, hFormat, lpProjMapName);
}

bool zmap_SaveMosaicAs(ZMAP hMap, const char* lpFileName) {
	if(!m_lpfn_map_SaveMosaicAs) {
		zeoReportError("zmap_SaveMosaicAs error - function not found");
		return false;
	}

	return m_lpfn_map_SaveMosaicAs(m_hID, hMap, lpFileName);
}
bool zmap_ExportMap(ZMAP hMap, const char* lpFileName, ZFORMAT hFormat, long nx, long ny) {
	if(!m_lpfn_map_ExportMap) {
		zeoReportError("zmap_ExportMap error - function not found");
		return false;
	}

	return m_lpfn_map_ExportMap(m_hID, hMap, lpFileName, hFormat, nx, ny);
}
bool zmap_ExportMosaic(ZMAP hMap, const char* lpFileName, ZFORMAT hFormat, long nx, long ny, long TileSize, const char* lpProjMapName) {
	if(!m_lpfn_map_ExportMosaic) {
		zeoReportError("zmap_ExportMosaic error - function not found");
		return false;
	}

	return m_lpfn_map_ExportMosaic(m_hID, hMap, lpFileName, hFormat, nx, ny, TileSize, lpProjMapName);
}

void* zmap_GetDataPtr(ZMAP hMap) {
	if(!m_lpfn_map_GetDataPtr) {
		zeoReportError("zmap_GetDataPtr error - function not found");
		return 0;
	}

	return m_lpfn_map_GetDataPtr(m_hID, hMap);
}
bool zmap_LinInterp(ZMAP hMap, double dx, double dy, void* pValue) {
	if(!m_lpfn_map_LinInterp) {
		zeoReportError("zmap_LinInterp error - function not found");
		return false;
	}

	return m_lpfn_map_LinInterp(m_hID, hMap, dx, dy, pValue);
}
void* zmap_GetMosaicTile(ZMAP hMap, long tx, long ty) {
	if(!m_lpfn_map_GetMosaicTile) {
		zeoReportError("zmap_GetMosaicTile error - function not found");
		return 0;
	}

	return m_lpfn_map_GetMosaicTile(m_hID, hMap, tx, ty);
}
bool zmap_GenMipmaps(ZMAP hMap, long ResStep, long MaxLevel, long TileSize) {
	if(!m_lpfn_map_GenMipmaps) {
		zeoReportError("zmap_GenMipmaps error - function not found");
		return false;
	}

	return m_lpfn_map_GenMipmaps(m_hID, hMap, ResStep, MaxLevel, TileSize);
}
bool zmap_ClearMipmaps(ZMAP hMap) {
	if(!m_lpfn_map_ClearMipmaps) {
		zeoReportError("zmap_ClearMipmaps error - function not found");
		return false;
	}

	return m_lpfn_map_ClearMipmaps(m_hID, hMap);
}
ZMAP zmap_GetMipmapLevel(ZMAP hMap, long MipLevel) {
	if(!m_lpfn_map_GetMipmapLevel) {
		zeoReportError("zmap_GetMipmapLevel error - function not found");
		return 0;
	}

	return m_lpfn_map_GetMipmapLevel(m_hID, hMap, MipLevel);
}
long zmap_GetMipmapResStep(ZMAP hMap) {
	if(!m_lpfn_map_GetMipmapResStep) {
		zeoReportError("zmap_GetMipmapResStep error - function not found");
		return 0;
	}

	return m_lpfn_map_GetMipmapResStep(m_hID, hMap);
}
long zmap_GetMipmapMaxLevel(ZMAP hMap) {
	if(!m_lpfn_map_GetMipmapMaxLevel) {
		zeoReportError("zmap_GetMipmapMaxLevel error - function not found");
		return 0;
	}

	return m_lpfn_map_GetMipmapMaxLevel(m_hID, hMap);
}

//
// mosaic tile functions
//

bool zmap_tile_GetPixel(void* hTile, long x, long y, void* pValue) {
	if(!m_lpfn_tile_GetPixel) {
		zeoReportError("zmap_tile_GetPixel error - function not found");
		return false;
	}

	return m_lpfn_tile_GetPixel(m_hID, hTile, x, y, pValue);
}
bool zmap_tile_SetPixel(void* hTile, long x, long y, void* pValue) {
	if(!m_lpfn_tile_SetPixel) {
		zeoReportError("zmap_tile_SetPixel error - function not found");
		return false;
	}

	return m_lpfn_tile_SetPixel(m_hID, hTile, x, y, pValue);
}
bool zmap_tile_GetMinMaxAlt(void* hTile, float& minval, float& maxval) {
	if(!m_lpfn_tile_GetMinMaxAlt) {
		zeoReportError("zmap_tile_GetMinMaxAlt error - function not found");
		return false;
	}

	return m_lpfn_tile_GetMinMaxAlt(m_hID, hTile, minval, maxval);
}
bool zmap_tile_GetTileCoords(void* hTile, long &x, long &y) {
	if(!m_lpfn_tile_GetTileCoords) {
		zeoReportError("zmap_tile_GetTileCoords error - function not found");
		return false;
	}

	return m_lpfn_tile_GetTileCoords(m_hID, hTile, x, y);
}
bool zmap_tile_SetLock(void* hTile, bool LockState) {
	if(!m_lpfn_tile_SetLock) {
		zeoReportError("zmap_tile_SetLock error - function not found");
		return false;
	}

	return m_lpfn_tile_SetLock(m_hID, hTile, LockState);
}
void* zmap_tile_GetDataPtr(void* hTile) {
	if(!m_lpfn_tile_GetDataPtr) {
		zeoReportError("zmap_tile_GetDataPtr error - function not found");
		return 0;
	}

	return m_lpfn_tile_GetDataPtr(m_hID, hTile);
}

bool zmap_tile_MarkChanged(void* hTile) {
	if(!m_lpfn_tile_MarkChanged) {
		zeoReportError("zmap_tile_MarkChanged error - function not found");
		return 0;
	}

	return m_lpfn_tile_MarkChanged(m_hID, hTile);
}

//
// format functions
//

ZFORMAT zformat_Create(const char* lpMapName, const char* lpLongName, const char* lpFileExt, const char* lpNativeProgramName) {
	if(!m_lpfn_format_Create) {
		zeoReportError("zformat_Create error - function not found");
		return 0;
	}

	return m_lpfn_format_Create(m_hID, lpMapName, lpLongName, lpFileExt, lpNativeProgramName);
}
ZFORMAT zformat_CreateGeneric(long MapTypeID, const char* lpLongName, const char* lpFileExt, const char* lpNativeProgramName) {
	if(!m_lpfn_format_Create) {
		zeoReportError("zformat_CreateGeneric error - function not found");
		return 0;
	}

	return m_lpfn_format_CreateGeneric(m_hID, MapTypeID, lpLongName, lpFileExt, lpNativeProgramName);
}
bool zformat_SetFlags(ZFORMAT hFormat, unsigned long Flags) {
	if(!m_lpfn_format_SetFlags) {
		zeoReportError("zformat_SetFlags error - function not found");
		return false;
	}

	return m_lpfn_format_SetFlags(m_hID, hFormat, Flags);
}
unsigned long zformat_GetFlags(ZFORMAT hFormat) {
	if(!m_lpfn_format_GetFlags) {
		zeoReportError("zformat_GetFlags error - function not found");
		return 0;
	}

	return m_lpfn_format_GetFlags(m_hID, hFormat);
}
bool zformat_SetInfoStr(ZFORMAT hFormat, const char* lpInfoStr) {
	if(!m_lpfn_format_SetInfoStr) {
		zeoReportError("zformat_SetInfoStr error - function not found");
		return false;
	}

	return m_lpfn_format_SetInfoStr(m_hID, hFormat, lpInfoStr);
}
const char* zformat_GetExt(ZFORMAT hFormat) {
	if(!m_lpfn_format_GetExt) {
		zeoReportError("zformat_GetExt error - function not found");
		return 0;
	}

	return m_lpfn_format_GetExt(m_hID, hFormat);
}
ZLIST zformat_GetOptionList(ZFORMAT hFormat) {
	if(!m_lpfn_format_GetOptionList) {
		zeoReportError("zformat_GetOptionList error - function not found");
		return 0;
	}

	return m_lpfn_format_GetOptionList(m_hID, hFormat);
}
bool zformat_SetOptionValue(ZFORMAT hFormat, const char* lpOptionName, long VarID, void* pValue) {
	if(!m_lpfn_format_SetOptionValue) {
		zeoReportError("zformat_SetOptionValue error - function not found");
		return false;
	}

	return m_lpfn_format_SetOptionValue(m_hID, hFormat, lpOptionName, VarID, pValue);
}
bool zformat_GetOptionValue(ZFORMAT hFormat, const char* lpOptionName, long VarID, void* pValue) {
	if(!m_lpfn_format_GetOptionValue) {
		zeoReportError("zformat_GetOptionValue error - function not found");
		return false;
	}

	return m_lpfn_format_GetOptionValue(m_hID, hFormat, lpOptionName, VarID, pValue);
}

ZFORMAT	zformat_GetFormatByExt(const char* lpMapName, long MapTypeID, const char* lpFileExt) {
	if(!m_lpfn_format_GetFormatByExt) {
		zeoReportError("zformat_GetFormatByExt error - function not found");
		return 0;
	}

	return m_lpfn_format_GetFormatByExt(m_hID, lpMapName, MapTypeID, lpFileExt);
}
ZLIST zformat_GetFormatList(const char* lpMapName, long MapTypeID) {
	if(!m_lpfn_format_GetFormatList) {
		zeoReportError("zformat_GetFormatList error - function not found");
		return 0;
	}

	return m_lpfn_format_GetFormatList(m_hID, lpMapName, MapTypeID);
}

ZFORMAT	zformat_GetFormatByExt2(ZMAP hMap, const char* lpFileExt) {
	
	ZVAR hStr = zvar_Create(VarID_string);

	zmap_GetNameInProject(hMap, hStr);

	ZLIST hRval = zformat_GetFormatByExt(zstr_GetText(hStr), zmap_GetMapType(hMap), lpFileExt);

	zvar_Delete(hStr);

	return hRval;

}
ZLIST zformat_GetFormatList2(ZMAP hMap) {

	ZVAR hStr = zvar_Create(VarID_string);

	zmap_GetNameInProject(hMap, hStr);

	ZLIST hRval = zformat_GetFormatList(zstr_GetText(hStr), zmap_GetMapType(hMap));

	zvar_Delete(hStr);

	return hRval;
}

ZFORMAT zformat_GetActiveFormat(const char* lpMapName, long MapTypeID) {
	if(!m_lpfn_format_GetActiveFormat) {
		zeoReportError("zformat_GetActiveFormat error - function not found");
		return false;
	}

	return m_lpfn_format_GetActiveFormat(m_hID, lpMapName, MapTypeID);
}

ZFORMAT zformat_GetDefaultFormat(const char* lpMapName, long MapTypeID) {
	if(!m_lpfn_format_GetDefaultFormat) {
		zeoReportError("zformat_GetDefaultFormat error - function not found");
		return false;
	}

	return m_lpfn_format_GetDefaultFormat(m_hID, lpMapName, MapTypeID);
}

//
// prog box functions
//

bool zprogbox_ShowWnd(ZVAR hProgWnd, unsigned long Flags) {
	if(!m_lpfn_progbox_ShowWnd) {
		zeoReportError("zprogbox_ShowWnd error - function not found");
		return false;
	}

	return m_lpfn_progbox_ShowWnd(m_hID, hProgWnd, Flags);
}
bool zprogbox_HideWnd(ZVAR hProgWnd) {
	if(!m_lpfn_progbox_HideWnd) {
		zeoReportError("zprogbox_HideWnd error - function not found");
		return false;
	}

	return m_lpfn_progbox_HideWnd(m_hID, hProgWnd);
}
bool zprogbox_SetTitle(ZVAR hProgWnd, const char* lpTitleText) {
	if(!m_lpfn_progbox_SetTitle) {
		zeoReportError("zprogbox_SetTitle error - function not found");
		return false;
	}

	return m_lpfn_progbox_SetTitle(m_hID, hProgWnd, lpTitleText);
}
bool zprogbox_SetProgress(ZVAR hProgWnd, __int64 p, __int64 pmax) {
	if(!m_lpfn_progbox_SetProgress) {
		zeoReportError("zprogbox_SetProgress error - function not found");
		return false;
	}

	return m_lpfn_progbox_SetProgress(m_hID, hProgWnd, p, pmax);
}

//
// file selector functions
//

bool zfilesel_Init(ZVAR hFileSel, bool OpenFileFlag, const char* lpFileName, const char* lpFilterStr, const char* lpDefaultExt, const char* lpDefaultDir) {
	if(!m_lpfn_filesel_InitFS) {
		zeoReportError("zfilesel_Init error - function not found");
		return false;
	}

	return m_lpfn_filesel_InitFS(m_hID, hFileSel, OpenFileFlag, lpFileName, lpFilterStr, lpDefaultExt, lpDefaultDir);
}
bool zfilesel_GetCurSelA(ZVAR hFileSel, ZSTR hReturnStr) {
	if(!m_lpfn_filesel_GetCurSelA) {
		zeoReportError("zfilesel_GetCurSelA error - function not found");
		return false;
	}

	return m_lpfn_filesel_GetCurSelA(m_hID, hFileSel, hReturnStr);
}

//
// dir selector functions
//

bool zdirsel_Init(ZVAR hDirSel, const char* lpStartDir) {
	if(!m_lpfn_dirsel_InitDS) {
		zeoReportError("zdirsel_Init error - function not found");
		return false;
	}

	return m_lpfn_dirsel_InitDS(m_hID, hDirSel, lpStartDir);
}
bool zdirsel_GetCurSelA(ZVAR hDirSel, ZSTR hReturnStr) {
	if(!m_lpfn_dirsel_GetCurSelA) {
		zeoReportError("zdirsel_GetCurSelA error - function not found");
		return false;
	}

	return m_lpfn_dirsel_GetCurSelA(m_hID, hDirSel, hReturnStr);
}

//
// combo box functions
//

bool zcombosel_Init(ZVAR hComboSel, const char* lpOptionsStr, const char* lpCurSelStr) {
	if(!m_lpfn_combosel_InitCS) {
		zeoReportError("zcombosel_Init error - function not found");
		return false;
	}

	return m_lpfn_combosel_InitCS(m_hID, hComboSel, lpOptionsStr, lpCurSelStr);
}
bool zcombosel_SetOptionsA(ZVAR hComboSel, const char* lpOptionsStr) {
	if(!m_lpfn_combosel_SetOptionsA) {
		zeoReportError("zcombosel_SetOptionsA error - function not found");
		return false;
	}

	return m_lpfn_combosel_SetOptionsA(m_hID, hComboSel, lpOptionsStr);
}
bool zcombosel_GetOptionsA(ZVAR hComboSel, ZSTR hReturnStr) {
	if(!m_lpfn_combosel_GetOptionsA) {
		zeoReportError("zcombosel_GetOptionsA error - function not found");
		return false;
	}

	return m_lpfn_combosel_GetOptionsA(m_hID, hComboSel, hReturnStr);
}
long zcombosel_GetCurSelI(ZVAR hComboSel) {
	if(!m_lpfn_combosel_GetCurSelI) {
		zeoReportError("zcombosel_GetCurSelI error - function not found");
		return -1;
	}

	return m_lpfn_combosel_GetCurSelI(m_hID, hComboSel);
}
bool zcombosel_SetCurSelI(ZVAR hComboSel, long CurSelID) {
	if(!m_lpfn_combosel_SetCurSelI) {
		zeoReportError("zcombosel_SetCurSelI error - function not found");
		return false;
	}

	return m_lpfn_combosel_SetCurSelI(m_hID, hComboSel, CurSelID);
}
bool zcombosel_SetCurSelA(ZVAR hComboSel, const char* lpCurSelStr) {
	if(!m_lpfn_combosel_SetCurSelA) {
		zeoReportError("zcombosel_SetCurSelA error - function not found");
		return false;
	}

	return m_lpfn_combosel_SetCurSelA(m_hID, hComboSel, lpCurSelStr);
}
bool zcombosel_GetCurSelA(ZVAR hComboSel, ZSTR hReturnStr) {
	if(!m_lpfn_combosel_GetCurSelA) {
		zeoReportError("zcombosel_GetCurSelA error - function not found");
		return false;
	}

	return m_lpfn_combosel_GetCurSelA(m_hID, hComboSel, hReturnStr);
}

//
// buffer functions
//

bool zbuffer_Init(ZVAR hBuf, long nItems, long ItemSize) {
	if(!m_lpfn_buffer_Init) {
		zeoReportError("zbuffer_Init error - function not found");
		return false;
	}

	return m_lpfn_buffer_Init(m_hID, hBuf, nItems, ItemSize);
}
bool zbuffer_InitByType(ZVAR hBuf, long nItems, long ItemTypeID) {
	if(!m_lpfn_buffer_InitByType) {
		zeoReportError("zbuffer_InitByType error - function not found");
		return false;
	}

	return m_lpfn_buffer_InitByType(m_hID, hBuf, nItems, ItemTypeID);
}
bool zbuffer_Free(ZVAR hBuf) {
	if(!m_lpfn_buffer_Free) {
		zeoReportError("zbuffer_Free error - function not found");
		return false;
	}

	return m_lpfn_buffer_Free(m_hID, hBuf);
}
long zbuffer_nItems(ZVAR hBuf) {
	if(!m_lpfn_buffer_nItems) {
		zeoReportError("zbuffer_nItems error - function not found");
		return 0;
	}

	return m_lpfn_buffer_nItems(m_hID, hBuf);
}
long zbuffer_MemSize(ZVAR hBuf) {
	if(!m_lpfn_buffer_MemSize) {
		zeoReportError("zbuffer_MemSize error - function not found");
		return 0;
	}

	return m_lpfn_buffer_MemSize(m_hID, hBuf);
}
long zbuffer_ItemSize(ZVAR hBuf) {
	if(!m_lpfn_buffer_ItemSize) {
		zeoReportError("zbuffer_ItemSize error - function not found");
		return 0;
	}

	return m_lpfn_buffer_ItemSize(m_hID, hBuf);
}
long zbuffer_ItemType(ZVAR hBuf) {
	if(!m_lpfn_buffer_ItemType) {
		zeoReportError("zbuffer_ItemType error - function not found");
		return 0;
	}

	return m_lpfn_buffer_ItemType(m_hID, hBuf);
}
void* zbuffer_GetPtr(ZVAR hBuf) {
	if(!m_lpfn_buffer_GetPtr) {
		zeoReportError("zbuffer_GetPtr error - function not found");
		return 0;
	}

	return m_lpfn_buffer_GetPtr(m_hID, hBuf);
}
bool zbuffer_GetValue(ZVAR hBuf, long index, void* pValue) {
	if(!m_lpfn_buffer_GetValue) {
		zeoReportError("zbuffer_GetValue error - function not found");
		return false;
	}

	return m_lpfn_buffer_GetValue(m_hID, hBuf, index, pValue);
}
bool zbuffer_SetValue(ZVAR hBuf, long index, void* pValue) {
	if(!m_lpfn_buffer_SetValue) {
		zeoReportError("zbuffer_SetValue error - function not found");
		return false;
	}

	return m_lpfn_buffer_SetValue(m_hID, hBuf, index, pValue);
}

//
// extension functions
//

ZFUNC zfunc_Load(const char* lpFnName, const char* lpExportName, long rvalVarID, ZLIST hArgList) {
	if(!m_lpfn_func_Load) {
		zeoReportError("zfunc_Load error - function not found");
		return 0;
	}

	return m_lpfn_func_Load(m_hID, lpFnName, lpExportName, rvalVarID, hArgList);
}
ZFUNC zfunc_GetFunc(const char* lpFnName) {
	if(!m_lpfn_func_GetFunc) {
		zeoReportError("zfunc_GetFunc error - function not found");
		return 0;
	}

	return m_lpfn_func_GetFunc(m_hID, lpFnName);
}
long zfunc_GetReturnTypeID(ZFUNC hFunc) {
	if(!m_lpfn_func_GetReturnTypeID) {
		zeoReportError("zfunc_GetReturnTypeID error - function not found");
		return 0;
	}

	return m_lpfn_func_GetReturnTypeID(m_hID, hFunc);
}
bool zfunc_GetArgListPrototype(ZFUNC hFunc, ZLIST hArgList) {
	if(!m_lpfn_func_GetArgListPrototype) {
		zeoReportError("zfunc_GetArgListPrototype error - function not found");
		return false;
	}

	return m_lpfn_func_GetArgListPrototype(m_hID, hFunc, hArgList);
}
bool zfunc_Execute(ZFUNC hFunc, ZLIST hArgList, ZVAR* ppRval) {
	if(!m_lpfn_func_Execute) {
		zeoReportError("zfunc_Execute error - function not found");
		return 0;
	}

	return m_lpfn_func_Execute(m_hID, hFunc, hArgList, ppRval);
}

//
// script functions
//

bool zscript_Execute(LPCSTR lpLangName, LPCSTR lpScript, ZVAR hRval) {
	if(!m_lpfn_script_Execute) {
		zeoReportError("zscript_Execute error - function not found");
		return false;
	}

	return m_lpfn_script_Execute(m_hID, lpLangName, lpScript, hRval);
}