#include <stdafx.h>
#include "ZeoScriptEx.h"

#include <Zeolite.h>

#include <zFunc.h>
#include <zList.h>
#include <zStr.h>

bool zs_Execute(const char* lpScript, ZLIST hScriptOptions, ZVAR* ppRval) {

	CzFunc fRunScript2;
	if(!fRunScript2.GetFunc("ZeoScript.RunScript2")) {
		zeoReportError("zs_Execute error:\r\n - cannot retrieve 'RunScript2' function");
		return false;
	}
	if(!zstr_SetText(fRunScript2.GetArgI(0), lpScript)) {
		zeoReportError("zs_Execute error:\r\n - cannot set arg0");
		return false;
	}
	if(!fRunScript2.SetArgValueI(1, VarID_hvar, &hScriptOptions)) {
		zeoReportError("zs_Execute error:\r\n - cannot set arg1");
		return false;
	}

	if(!fRunScript2.Execute2(NULL, ppRval)) {
		zeoWriteToLog("zs_Execute error:\r\n - script execution failed");
		return false;
	}

	return true;
}