#include <Zeolite.h>
#include "zCalcMap.h"
#include <zVar.h>
#include <zStr.h>
#include <zMap.h>
#include <zFunc.h>

bool zCalcMap_Resize(ZMAP pSrc, ZMAP pDest, long nx, long ny, unsigned long Flags) {
	
	CzFunc f;
	if(!f.GetFunc("calc.map.Resize")) {
		return false;
	}

	long ArgID = 0;
	if(!f.m_args.SetItemValue(ArgID++, VarID_hvar, &pSrc))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_hvar, &pDest))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_int, &nx))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_int, &ny))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_uint, &Flags))
		return false;

	CzVar rval;
	rval.Attach(f.Execute());

	bool b = false;
	if(!rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}

bool zCalcMap_CopyArea(ZMAP pSrc, long sx0, long sy0, long snx, long sny, ZMAP pDest, long dx0, long dy0,  unsigned long Flags) {

	CzFunc f;
	if(!f.GetFunc("calc.map.CopyArea")) {
		return false;
	}

	long ArgID = 0;
	if(!f.m_args.SetItemValue(ArgID++, VarID_hvar, &pSrc))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_int, &sx0))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_int, &sy0))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_int, &snx))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_int, &sny))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_hvar, &pDest))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_int, &dx0))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_int, &dy0))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_uint, &Flags))
		return false;

	CzVar rval;
	rval.Attach(f.Execute());

	bool b = false;
	if(!rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}

bool zCalcMap_RotateCW(ZMAP pMap, bool ShowProgress) {
	CzFunc f;
	if(!f.GetFunc("calc.map.RotateCW")) {
		return false;
	}

	long ArgID = 0;
	if(!f.m_args.SetItemValue(ArgID++, VarID_hvar, &pMap))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_bool, &ShowProgress))
		return false;

	CzVar rval;
	rval.Attach(f.Execute());

	bool b = false;
	if(!rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}
bool zCalcMap_RotateCCW(ZMAP pMap, bool ShowProgress) {
	CzFunc f;
	if(!f.GetFunc("calc.map.RotateCCW")) {
		return false;
	}

	long ArgID = 0;
	if(!f.m_args.SetItemValue(ArgID++, VarID_hvar, &pMap))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_bool, &ShowProgress))
		return false;

	CzVar rval;
	rval.Attach(f.Execute());

	bool b = false;
	if(!rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}
bool zCalcMap_MirrorX(ZMAP pMap, bool ShowProgress) {
	CzFunc f;
	if(!f.GetFunc("calc.map.MirrorX")) {
		return false;
	}

	long ArgID = 0;
	if(!f.m_args.SetItemValue(ArgID++, VarID_hvar, &pMap))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_bool, &ShowProgress))
		return false;

	CzVar rval;
	rval.Attach(f.Execute());

	bool b = false;
	if(!rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}
bool zCalcMap_MirrorY(ZMAP pMap, bool ShowProgress) {
	CzFunc f;
	if(!f.GetFunc("calc.map.MirrorY")) {
		return false;
	}

	long ArgID = 0;
	if(!f.m_args.SetItemValue(ArgID++, VarID_hvar, &pMap))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_bool, &ShowProgress))
		return false;

	CzVar rval;
	rval.Attach(f.Execute());

	bool b = false;
	if(!rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}
bool zCalcMap_MirrorXY(ZMAP pMap, bool ShowProgress) {
	CzFunc f;
	if(!f.GetFunc("calc.map.MirrorXY")) {
		return false;
	}

	long ArgID = 0;
	if(!f.m_args.SetItemValue(ArgID++, VarID_hvar, &pMap))
		return false;
	if(!f.m_args.SetItemValue(ArgID++, VarID_bool, &ShowProgress))
		return false;

	CzVar rval;
	rval.Attach(f.Execute());

	bool b = false;
	if(!rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}