#include <Zeolite.h>
#include "zSettings.h"
#include <zClasses.h>
#include <zFunc.h>

ZLIST zsettings_GetLocalList() {

	CzFunc f;
	if(!f.GetFunc("settings.GetLocalList")) {
		zeoReportError("zsettings_GetLocalList error:\r\n - cannot get function");
		return NULL;
	}
	if(!f.Execute2()) {
		zeoReportError("zsettings_GetLocalList error:\r\n - function call failed");
		return NULL;
	}

	ZLIST hRval = NULL;
	if(!f.m_rval.GetValue(VarID_hvar, &hRval)) {
		zeoReportError("zsettings_GetLocalList error:\r\n - cannot get return value");
		return NULL;
	}

	return hRval;
}
ZLIST zsettings_GetPresetsList() {

	CzFunc f;
	if(!f.GetFunc("settings.GetPresetsList")) {
		zeoReportError("zsettings_GetLocalList error:\r\n - cannot get function");
		return NULL;
	}
	if(!f.Execute2()) {
		zeoReportError("zsettings_GetLocalList error:\r\n - function call failed");
		return NULL;
	}

	ZLIST hRval = NULL;
	if(!f.m_rval.GetValue(VarID_hvar, &hRval)) {
		zeoReportError("zsettings_GetLocalList error:\r\n - cannot get return value");
		return NULL;
	}

	return hRval;
}


bool zsettings_SetWndSetting(long DPI, const char* lpSettingName, long VarID, void* pValue) {
	
	CzFunc f;
	if(!f.GetFunc("settings.SetWndSetting")) {
		zeoReportError("zsettings_SetWndSetting error:\r\n - cannot get function");
		return false;
	}
	int argid = 0;
	if(!f.SetArgValueI(argid++, VarID_int, &DPI)) {
		zeoReportError("zsettings_SetWndSetting error:\r\n - cannot set arg");
		return false;
	}
	if(!zstr_SetText(f.GetArgI(argid++), lpSettingName)) {
		zeoReportError("zsettings_SetWndSetting error:\r\n - cannot set arg");
		return false;
	}

	CzVar v;
	if(!v.Create(VarID)) {
		zeoReportError("zsettings_SetWndSetting error:\r\n - cannot create value var");
		return false;
	}
	if(!v.SetValue(VarID, pValue)) {
		zeoReportError("zsettings_SetWndSetting error:\r\n - cannot set value var");
		return false;
	}
	ZVAR hValue = v.GetZVAR();

	if(!f.SetArgValueI(argid++, VarID_hvar, &hValue)) {
		zeoReportError("zsettings_SetWndSetting error:\r\n - cannot set arg");
		return false;
	}
	if(!f.Execute2()) {
		zeoReportError("zsettings_SetWndSetting error:\r\n - function call failed");
		return false;
	}

	return true;
}
bool zsettings_GetWndSetting(long DPI, const char* lpSettingName, long VarID, void* pValue, bool INF_Create, bool INF_Interp96) {
	CzFunc f;
	if(!f.GetFunc("settings.GetWndSetting")) {
		zeoReportError("zsettings_SetWndSetting error:\r\n - cannot get function");
		return false;
	}
	int argid = 0;
	if(!f.SetArgValueI(argid++, VarID_int, &DPI)) {
		zeoReportError("zsettings_GetWndSetting error:\r\n - cannot set arg");
		return false;
	}
	if(!zstr_SetText(f.GetArgI(argid++), lpSettingName)) {
		zeoReportError("zsettings_GetWndSetting error:\r\n - cannot set arg");
		return false;
	}

	CzVar v;
	if(!v.Create(VarID)) {
		zeoReportError("zsettings_GetWndSetting error:\r\n - cannot create value var");
		return false;
	}
	if(!v.SetValue(VarID, pValue)) {
		zeoReportError("zsettings_GetWndSetting error:\r\n - cannot set value var");
		return false;
	}
	ZVAR hValue = v.GetZVAR();
	if(!f.SetArgValueI(argid++, VarID_hvar, &hValue)) {
		zeoReportError("zsettings_GetWndSetting error:\r\n - cannot set arg");
		return false;
	}

	if(!f.SetArgValueI(argid++, VarID_bool, &INF_Create)) {
		zeoReportError("zsettings_GetWndSetting error:\r\n - cannot set arg");
		return false;
	}
	if(!f.SetArgValueI(argid++, VarID_bool, &INF_Interp96)) {
		zeoReportError("zsettings_GetWndSetting error:\r\n - cannot set arg");
		return false;
	}
	if(!f.Execute2()) {
		zeoReportError("zsettings_GetWndSetting error:\r\n - function call failed");
		return false;
	}

	if(!v.GetValue(VarID, pValue)) {
		zeoReportError("zsettings_GetWndSetting error:\r\n - cannot get value var");
		return false;
	}

	return true;
}