#include "Zeolite.h"
#include "zcolour.h"

CzColour::CzColour(void) {
	Create();
}

CzColour::~CzColour(void) {
}

bool CzColour::Create() {
	return CzVar::Create(VarID_colour);
}
bool CzColour::CreateShared(const char* lpVarName) {
	return CzVar::CreateShared(VarID_colour, lpVarName);
}

BYTE CzColour::GetR() {
	ColourPixel ColPxl;
	if(!zvar_GetValueEx(m_hVar, VarID_colour, &ColPxl))
		return 0;

	return ColPxl.r;
}
BYTE CzColour::GetG() {
	ColourPixel ColPxl;
	if(!zvar_GetValueEx(m_hVar, VarID_colour, &ColPxl))
		return 0;

	return ColPxl.g;
}
BYTE CzColour::GetB() {
	ColourPixel ColPxl;
	if(!zvar_GetValueEx(m_hVar, VarID_colour, &ColPxl))
		return 0;

	return ColPxl.b;
}

COLORREF CzColour::GetCOLORREF() {
	ColourPixel ColPxl;
	if(!zvar_GetValueEx(m_hVar, VarID_colour, &ColPxl))
		return RGB(0, 0, 0);

	return RGB(ColPxl.r, ColPxl.g, ColPxl.b);
}

bool CzColour::SetRGB(BYTE r, BYTE g, BYTE b) {
	ColourPixel ColPxl;
	ColPxl.r = r;
	ColPxl.g = g;
	ColPxl.b = b;
	if(!zvar_SetValueEx(m_hVar, VarID_colour, &ColPxl))
		return false;

	return true;
}
bool CzColour::SetRGB(COLORREF ColRef) {
	ColourPixel ColPxl;
	ColPxl.r = GetRValue(ColRef);
	ColPxl.g = GetGValue(ColRef);
	ColPxl.b = GetBValue(ColRef);
	if(!zvar_SetValueEx(m_hVar, VarID_colour, &ColPxl))
		return false;

	return true;
}