#include "Zeolite.h"
#include "zfunc.h"

CzFunc::CzFunc(void) {
}
CzFunc::CzFunc(const char* lpFuncName) {
	GetFunc(lpFuncName);
}

CzFunc::~CzFunc(void) {
}

bool CzFunc::Load(const char* lpFnName, const char* lpExportName, long rvalVarID, ZLIST hArgList) {
	return Attach(zfunc_Load(lpFnName, lpExportName, rvalVarID, hArgList));
}
bool CzFunc::GetFunc(const char* lpFnName) {
	return Attach(zfunc_GetFunc(lpFnName));
}
long CzFunc::GetReturnTypeID() {
	if(!m_hVar)	return 0;

	return zfunc_GetReturnTypeID(m_hVar);
}
bool CzFunc::GetArgListPrototype(ZLIST hArgList) {
	if(!m_hVar)	return false;

	return zfunc_GetArgListPrototype(m_hVar, hArgList);
}
ZVAR CzFunc::Execute() {
	if(!m_hVar)	return NULL;

	ZVAR hArgList = m_args.GetZVAR();
	ZVAR hRval = m_rval.GetZVAR();

	if(!zfunc_Execute(m_hVar, hArgList, &hRval)) {
		return NULL;
	}
	
	return hRval;
}
bool CzFunc::Execute2(ZLIST hArgList, ZVAR* ppRval) {

	if(!m_hVar)	
		return false;

	bool rval = false;

	if(!hArgList) {
		hArgList = m_args.GetZVAR();
	}

	ZVAR hRval = m_rval.GetZVAR();

	if(!zfunc_Execute(m_hVar, hArgList, &hRval)) {
		return false;
	}

	if(ppRval) {
		*ppRval = hRval;
	}
	
	return true;
}

bool CzFunc::Attach(ZVAR hVar) {
	if(!CzVar::Attach(hVar))	return false;

	if(!IsType(VarID_zeofunc)) {
		Delete();
		return false;
	}

	// get the arg list
	if(!GetArgListPrototype(m_args.GetZVAR())) {
		Delete();
		return false;
	}

	// initialise the return value
	m_rval.Delete();
	if(!m_rval.Create(zfunc_GetReturnTypeID(hVar))) {
		return false;
	}

	return true;
}

ZVAR CzFunc::GetArgI(long index) {
	if(!m_hVar)	
		return false;

	return m_args.GetItemI(index);
}
ZVAR CzFunc::GetArgA(const char* lpArgName) {
	if(!m_hVar)	
		return false;

	return m_args.GetItemA(lpArgName);
}
bool CzFunc::SetArgValueI(long index, long VarID, void* pValue) {
	if(!m_hVar)	
		return false;

	return m_args.SetItemValueI(index, VarID, pValue);
}
bool CzFunc::SetArgValueA(const char* lpArgName, long VarID, void* pValue) {
	if(!m_hVar)	
		return false;

	return m_args.SetItemValueA(lpArgName, VarID, pValue);
}