#pragma once
#include "zvar.h"


#define MESHMODE_POINTS                         0x0000
#define MESHMODE_LINES                          0x0001
#define MESHMODE_LINE_LOOP                      0x0002
#define MESHMODE_LINE_STRIP                     0x0003
#define MESHMODE_TRIANGLES                      0x0004
#define MESHMODE_TRIANGLE_STRIP                 0x0005
#define MESHMODE_TRIANGLE_FAN                   0x0006
#define MESHMODE_QUADS                          0x0007
#define MESHMODE_QUAD_STRIP                     0x0008
#define MESHMODE_POLYGON                        0x0009

class CzMeshFaceGroup :
	public CzVar
{
public:
	CzMeshFaceGroup(void);
	~CzMeshFaceGroup(void);

	bool CreateData(ZLIST hTarget = NULL);
	virtual bool Attach(ZVAR hVar);

	bool Init(long MeshMode, const char* lpMtlName, ZBUF hVertIndexBuf, ZBUF hNormIndexBuf, ZBUF hTexIndexBuf);
	bool SetVertIndexBuf(ZBUF hBuf);
	bool SetNormIndexBuf(ZBUF hBuf);
	bool SetTexIndexBuf(ZBUF hBuf);

	long GetMeshMode();
	bool SetMeshMode(long MeshMode);

	const char* GetMaterialName();
	bool SetMaterialName(const char* lpMtlName);

	ZBUF GetVertIndexBuf() { return m_hVar?m_hVertIndices:NULL; }
	ZBUF GetNormIndexBuf() { return m_hVar?m_hNormIndices:NULL; }
	ZBUF GetTexIndexBuf() { return m_hVar?m_hTexIndices:NULL; }

	ZSTR GetInfoEx() { return m_hVar?m_hInfoEx:NULL; }
	
protected:

	ZVAR m_hMeshMode; // an int

	ZBUF m_hVertIndices;
	ZBUF m_hNormIndices;
	ZBUF m_hTexIndices;

	ZSTR m_hMtlName;

	ZLIST m_hInfoEx;
};
