#pragma once
#include "zvar.h"

class CzMeshMtl :
	public CzVar
{
public:
	CzMeshMtl(void);
	~CzMeshMtl(void);

	bool CreateData(ZLIST hTarget = NULL);  // if hTarget is valid, the mesh will attach to it (must be empty) and initialise contents

	virtual bool Attach(ZVAR hVar);

	bool GetAmbCol(vector4f** ppColour);
	bool GetDiffCol(vector4f** ppColour);
	bool GetSpecCol(vector4f** ppColour);
	bool GetSpecPower(float** ppValue);

	ZSTR GetAmbImageFile() { return m_hVar?m_hAmbImageFile:NULL; }
	ZSTR GetDiffImageFile() { return m_hVar?m_hDiffImageFile:NULL; }
	ZSTR GetSpecImageFile() { return m_hVar?m_hSpecImageFile:NULL; }

	ZLIST GetInfoEx() { return m_hVar?m_hInfoEx:NULL; }

	bool SetAmbient(vector4f col, const char* lpImageFile);
	bool SetDiffuse(vector4f col, const char* lpImageFile);
	bool SetSpecular(vector4f col, const char* lpImageFile, float SpecPower);

protected:

	ZVAR m_hAmbCol;  // as vector4f
	ZVAR m_hDiffCol; // as vector4f
	ZVAR m_hSpecCol; // as vector4f
	
	ZVAR m_hSpecPower; // as float

	ZSTR m_hAmbImageFile;
	ZSTR m_hDiffImageFile;
	ZSTR m_hSpecImageFile;

	ZLIST m_hInfoEx; // options not understood by base mesh class, but may be useful for renderer or file format
};
