#pragma once
#include "zvar.h"

class CzStr :
	public CzVar
{
public:
	CzStr(void);
	~CzStr(void);

	bool Create();
	bool CreateShared(const char* lpVarName);

	const char* GetText();
	bool SetText(const char* lpTextStr);

	long GetLength();
	long Compare(const char* lpText);
	long CompareNoCase(const char* lpText);
	bool IsStr(const char* lpText);

	long Find(const char* lpText, long StartPos = 0);

	const char* Append(const char* lpNewText);
	const char* AppendChar(char c);

	char GetAt(long index);

	//Cast-to-const char* operator
	operator const char* () {
		return GetText();
	}
	//Cast-to-char* operator
	operator char* () {
		return (char*)GetText();
	}

	// assignment operator
	bool operator = (const char* lpTextStr) {
		return SetText(lpTextStr);
	}

	// index operator
    char operator [] (long index) {
        return GetAt(index);
    } 
};
